/*
 * Copyright (C) 2008-2015 TrinityCore <http://www.trinitycore.org/>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DURATION_H_
#define _DURATION_H_

#include <chrono>

/// Milliseconds shorthand typedef.
typedef std::chrono::milliseconds Milliseconds;

/// Seconds shorthand typedef.
typedef std::chrono::seconds Seconds;

/// Minutes shorthand typedef.
typedef std::chrono::minutes Minutes;

/// Hours shorthand typedef.
typedef std::chrono::hours Hours;

/// Point in time shorthand typedef.
typedef std::chrono::steady_clock::time_point TimePoint;

/// Represents a monotonic clock typedef.
typedef std::chrono::steady_clock SteadyClock;

/// The system-wide real time wall clock typedef.
typedef std::chrono::system_clock SystemClock;

/// Represents a time interval typedef.
typedef std::chrono::system_clock::duration Duration;

/// Makes std::chrono_literals globally available.
// ToDo: Enable this when TC supports C++14.
// using namespace std::chrono_literals;

#endif // _DURATION_H_
