/*
 * Copyright (C) 2008-2015 TrinityCore <http://www.trinitycore.org/>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GarrisonMap_h__
#define GarrisonMap_h__

#include "Map.h"

class Garrison;
class Player;

class GarrisonMap : public InstanceMap
{
public:
    GarrisonMap(uint32 id, time_t, uint32 instanceId, Map* parent, ObjectGuid const& owner);

    Garrison* GetGarrison();

    void InitVisibilityDistance() override;

    bool AddPlayerToMap(Player* player, bool initPlayer = true) override;

private:
    bool onEnsureGridLoaded(NGrid* grid, Cell const& cell) override;
    Garrison* _garrison;
    ObjectGuid _owner;
};

#endif // GarrisonMap_h__
