/*
 * Copyright (C) 2008-2012 TrinityCore <http://www.trinitycore.org/>
 * Copyright (C) 2005-2010 MaNGOS <http://getmangos.com/>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHARACTERDATABASECLEANER_H
#define CHARACTERDATABASECLEANER_H

namespace CharacterDatabaseCleaner
{
    enum CleaningFlags
    {
        CLEANING_FLAG_ACHIEVEMENT_PROGRESS  = 0x1,
        CLEANING_FLAG_SKILLS                = 0x2,
        CLEANING_FLAG_SPELLS                = 0x4,
        CLEANING_FLAG_QUESTSTATUS           = 0x10,
        CLEANING_FLAG_PETSLOT               = 0x20      //Now used for store pet slots on new plr field, after for find lost link pets.
    };

    void CleanDatabase();

    void CheckUnique(const char* column, const char* table, bool (*check)(uint32));

    bool AchievementProgressCheck(uint32 criteria);
    bool SkillCheck(uint32 skill);
    bool SpellCheck(uint32 spell_id);

    void CleanAllAchievementProgress();
    void CleanGuildAchievementProgress();
    void CleanAccountAchievementProgress();
    void CleanCharacterAchievementProgress();
    void CleanCharacterSkills();
    void CleanCharacterSpell();
    void CleanCharacterQuestStatus();
    void CleanPetSlots();
}

#endif
