/*
 * Copyright (C) 2008-2016 TrinityCore <http://www.trinitycore.org/>
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef BattlenetRpcErrorCodes_h__
#define BattlenetRpcErrorCodes_h__

#include "Define.h"

enum BattlenetRpcErrorCode : uint32
{
    ERROR_OK                                                                = 0x00000000,
    ERROR_INTERNAL                                                          = 0x00000001,
    ERROR_TIMED_OUT                                                         = 0x00000002,
    ERROR_DENIED                                                            = 0x00000003,
    ERROR_NOT_EXISTS                                                        = 0x00000004,
    ERROR_NOT_STARTED                                                       = 0x00000005,
    ERROR_IN_PROGRESS                                                       = 0x00000006,
    ERROR_INVALID_ARGS                                                      = 0x00000007,
    ERROR_INVALID_SUBSCRIBER                                                = 0x00000008,
    ERROR_WAITING_FOR_DEPENDENCY                                            = 0x00000009,
    ERROR_NO_AUTH                                                           = 0x0000000A,
    ERROR_PARENTAL_CONTROL_RESTRICTION                                      = 0x0000000B,
    ERROR_NO_GAME_ACCOUNT                                                   = 0x0000000C,
    ERROR_NOT_IMPLEMENTED                                                   = 0x0000000D,
    ERROR_OBJECT_REMOVED                                                    = 0x0000000E,
    ERROR_INVALID_ENTITY_ID                                                 = 0x0000000F,
    ERROR_INVALID_ENTITY_ACCOUNT_ID                                         = 0x00000010,
    ERROR_INVALID_ENTITY_GAME_ACCOUNT_ID                                    = 0x00000011,
    ERROR_INVALID_AGENT_ID                                                  = 0x00000013,
    ERROR_INVALID_TARGET_ID                                                 = 0x00000014,
    ERROR_MODULE_NOT_LOADED                                                 = 0x00000015,
    ERROR_MODULE_NO_ENTRY_POINT                                             = 0x00000016,
    ERROR_MODULE_SIGNATURE_INCORRECT                                        = 0x00000017,
    ERROR_MODULE_CREATE_FAILED                                              = 0x00000018,
    ERROR_NO_PROGRAM                                                        = 0x00000019,
    ERROR_API_NOT_READY                                                     = 0x0000001B,
    ERROR_BAD_VERSION                                                       = 0x0000001C,
    ERROR_ATTRIBUTE_TOO_MANY_ATTRIBUTES_SET                                 = 0x0000001D,
    ERROR_ATTRIBUTE_MAX_SIZE_EXCEEDED                                       = 0x0000001E,
    ERROR_ATTRIBUTE_QUOTA_EXCEEDED                                          = 0x0000001F,
    ERROR_SERVER_POOL_SERVER_DISAPPEARED                                    = 0x00000020,
    ERROR_SERVER_IS_PRIVATE                                                 = 0x00000021,
    ERROR_DISABLED                                                          = 0x00000022,
    ERROR_MODULE_NOT_FOUND                                                  = 0x00000024,
    ERROR_SERVER_BUSY                                                       = 0x00000025,
    ERROR_NO_BATTLETAG                                                      = 0x00000026,
    ERROR_INCOMPLETE_PROFANITY_FILTERS                                      = 0x00000027,
    ERROR_INVALID_REGION                                                    = 0x00000028,
    ERROR_EXISTS_ALREADY                                                    = 0x00000029,
    ERROR_INVALID_SERVER_THUMBPRINT                                         = 0x0000002A,
    ERROR_PHONE_LOCK                                                        = 0x0000002B,
    ERROR_SQUELCHED                                                         = 0x0000002C,
    ERROR_TARGET_OFFLINE                                                    = 0x0000002D,
    ERROR_BAD_SERVER                                                        = 0x0000002E,
    ERROR_NO_COOKIE                                                         = 0x0000002F,
    ERROR_EXPIRED_COOKIE                                                    = 0x00000030,
    ERROR_TOKEN_NOT_FOUND                                                   = 0x00000031,
    ERROR_GAME_ACCOUNT_NO_TIME                                              = 0x00000032,
    ERROR_GAME_ACCOUNT_NO_PLAN                                              = 0x00000033,
    ERROR_GAME_ACCOUNT_BANNED                                               = 0x00000034,
    ERROR_GAME_ACCOUNT_SUSPENDED                                            = 0x00000035,
    ERROR_GAME_ACCOUNT_ALREADY_SELECTED                                     = 0x00000036,
    ERROR_GAME_ACCOUNT_CANCELLED                                            = 0x00000037,
    ERROR_GAME_ACCOUNT_CREATION_DISABLED                                    = 0x00000038,
    ERROR_GAME_ACCOUNT_LOCKED                                               = 0x00000039,

    ERROR_SESSION_DUPLICATE                                                 = 0x0000003C,
    ERROR_SESSION_DISCONNECTED                                              = 0x0000003D,
    ERROR_SESSION_DATA_CHANGED                                              = 0x0000003E,
    ERROR_SESSION_UPDATE_FAILED                                             = 0x0000003F,
    ERROR_SESSION_NOT_FOUND                                                 = 0x00000040,

    ERROR_ADMIN_KICK                                                        = 0x00000046,
    ERROR_UNPLANNED_MAINTENANCE                                             = 0x00000047,
    ERROR_PLANNED_MAINTENANCE                                               = 0x00000048,
    ERROR_SERVICE_FAILURE_ACCOUNT                                           = 0x00000049,
    ERROR_SERVICE_FAILURE_SESSION                                           = 0x0000004A,
    ERROR_SERVICE_FAILURE_AUTH                                              = 0x0000004B,
    ERROR_SERVICE_FAILURE_RISK                                              = 0x0000004C,
    ERROR_BAD_PROGRAM                                                       = 0x0000004D,
    ERROR_BAD_LOCALE                                                        = 0x0000004E,
    ERROR_BAD_PLATFORM                                                      = 0x0000004F,
    ERROR_LOCALE_RESTRICTED_LA                                              = 0x00000051,
    ERROR_LOCALE_RESTRICTED_RU                                              = 0x00000052,
    ERROR_LOCALE_RESTRICTED_KO                                              = 0x00000053,
    ERROR_LOCALE_RESTRICTED_TW                                              = 0x00000054,
    ERROR_LOCALE_RESTRICTED                                                 = 0x00000055,
    ERROR_ACCOUNT_NEEDS_MAINTENANCE                                         = 0x00000056,
    ERROR_MODULE_API_ERROR                                                  = 0x00000057,
    ERROR_MODULE_BAD_CACHE_HANDLE                                           = 0x00000058,
    ERROR_MODULE_ALREADY_LOADED                                             = 0x00000059,
    ERROR_NETWORK_BLACKLISTED                                               = 0x0000005A,
    ERROR_EVENT_PROCESSOR_SLOW                                              = 0x0000005B,
    ERROR_SERVER_SHUTTING_DOWN                                              = 0x0000005C,
    ERROR_NETWORK_NOT_PRIVILEGED                                            = 0x0000005D,
    ERROR_TOO_MANY_OUTSTANDING_REQUESTS                                     = 0x0000005E,
    ERROR_NO_ACCOUNT_REGISTERED                                             = 0x0000005F,
    ERROR_BATTLENET_ACCOUNT_BANNED                                          = 0x00000060,

    ERROR_OK_DEPRECATED                                                     = 0x00000064,
    ERROR_SERVER_IN_MODE_ZOMBIE                                             = 0x00000065,

    ERROR_LOGON_MODULE_REQUIRED                                             = 0x000001F4,
    ERROR_LOGON_MODULE_NOT_CONFIGURED                                       = 0x000001F5,
    ERROR_LOGON_MODULE_TIMEOUT                                              = 0x000001F6,
    ERROR_LOGON_AGREEMENT_REQUIRED                                          = 0x000001FE,
    ERROR_LOGON_AGREEMENT_NOT_CONFIGURED                                    = 0x000001FF,

    ERROR_LOGON_INVALID_SERVER_PROOF                                        = 0x00000208,
    ERROR_LOGON_WEB_VERIFY_TIMEOUT                                          = 0x00000209,
    ERROR_LOGON_INVALID_AUTH_TOKEN                                          = 0x0000020A,

    ERROR_CHALLENGE_SMS_TOO_SOON                                            = 0x00000258,
    ERROR_CHALLENGE_SMS_THROTTLED                                           = 0x00000259,
    ERROR_CHALLENGE_SMS_TEMP_OUTAGE                                         = 0x0000025A,
    ERROR_CHALLENGE_NO_CHALLENGE                                            = 0x0000025B,
    ERROR_CHALLENGE_NOT_PICKED                                              = 0x0000025C,
    ERROR_CHALLENGE_ALREADY_PICKED                                          = 0x0000025D,
    ERROR_CHALLENGE_IN_PROGRESS                                             = 0x0000025E,

    ERROR_CONFIG_FORMAT_INVALID                                             = 0x000002BC,
    ERROR_CONFIG_NOT_FOUND                                                  = 0x000002BD,
    ERROR_CONFIG_RETRIEVE_FAILED                                            = 0x000002BE,

    ERROR_NETWORK_MODULE_BUSY                                               = 0x000003E8,
    ERROR_NETWORK_MODULE_CANT_RESOLVE_ADDRESS                               = 0x000003E9,
    ERROR_NETWORK_MODULE_CONNECTION_REFUSED                                 = 0x000003EA,
    ERROR_NETWORK_MODULE_INTERRUPTED                                        = 0x000003EB,
    ERROR_NETWORK_MODULE_CONNECTION_ABORTED                                 = 0x000003EC,
    ERROR_NETWORK_MODULE_CONNECTION_RESET                                   = 0x000003ED,
    ERROR_NETWORK_MODULE_BAD_ADDRESS                                        = 0x000003EE,
    ERROR_NETWORK_MODULE_NOT_READY                                          = 0x000003EF,
    ERROR_NETWORK_MODULE_ALREADY_CONNECTED                                  = 0x000003F0,
    ERROR_NETWORK_MODULE_CANT_CREATE_SOCKET                                 = 0x000003F1,
    ERROR_NETWORK_MODULE_NETWORK_UNREACHABLE                                = 0x000003F2,
    ERROR_NETWORK_MODULE_SOCKET_PERMISSION_DENIED                           = 0x000003F3,
    ERROR_NETWORK_MODULE_NOT_INITIALIZED                                    = 0x000003F4,
    ERROR_NETWORK_MODULE_NO_SSL_CERTIFICATE_FOR_PEER                        = 0x000003F5,
    ERROR_NETWORK_MODULE_NO_SSL_COMMON_NAME_FOR_CERTIFICATE                 = 0x000003F6,
    ERROR_NETWORK_MODULE_SSL_COMMON_NAME_DOES_NOT_MATCH_REMOTE_ENDPOINT     = 0x000003F7,
    ERROR_NETWORK_MODULE_SOCKET_CLOSED                                      = 0x000003F8,
    ERROR_NETWORK_MODULE_SSL_PEER_IS_NOT_REGISTERED_IN_CERTBUNDLE           = 0x000003F9,
    ERROR_NETWORK_MODULE_SSL_INITIALIZE_LOW_FIRST                           = 0x000003FA,
    ERROR_NETWORK_MODULE_SSL_CERT_BUNDLE_READ_ERROR                         = 0x000003FB,
    ERROR_NETWORK_MODULE_NO_CERT_BUNDLE                                     = 0x000003FC,
    ERROR_NETWORK_MODULE_FAILED_TO_DOWNLOAD_CERT_BUNDLE                     = 0x000003FD,
    ERROR_NETWORK_MODULE_NOT_READY_TO_READ                                  = 0x000003FE,

    ERROR_NETWORK_MODULE_OPENSSL_X509_OK                                    = 0x000004B0,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_GET_ISSUER_CERT             = 0x000004B1,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_GET_CRL                     = 0x000004B2,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_DECRYPT_CERT_SIGNATURE      = 0x000004B3,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_DECRYPT_CRL_SIGNATURE       = 0x000004B4,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY    = 0x000004B5,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_SIGNATURE_FAILURE                = 0x000004B6,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CRL_SIGNATURE_FAILURE                 = 0x000004B7,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_NOT_YET_VALID                    = 0x000004B8,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_HAS_EXPIRED                      = 0x000004B9,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CRL_NOT_YET_VALID                     = 0x000004BA,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CRL_HAS_EXPIRED                       = 0x000004BB,
    ERROR_NETWORK_MODULE_OPENSSL_X509_ERROR_IN_CERT_NOT_BEFORE_FIELD        = 0x000004BC,
    ERROR_NETWORK_MODULE_OPENSSL_X509_ERROR_IN_CERT_NOT_AFTER_FIELD         = 0x000004BD,
    ERROR_NETWORK_MODULE_OPENSSL_X509_ERROR_IN_CRL_LAST_UPDATE_FIELD        = 0x000004BE,
    ERROR_NETWORK_MODULE_OPENSSL_X509_ERROR_IN_CRL_NEXT_UPDATE_FIELD        = 0x000004BF,
    ERROR_NETWORK_MODULE_OPENSSL_X509_OUT_OF_MEM                            = 0x000004C0,
    ERROR_NETWORK_MODULE_OPENSSL_X509_DEPTH_ZERO_SELF_SIGNED_CERT           = 0x000004C1,
    ERROR_NETWORK_MODULE_OPENSSL_X509_SELF_SIGNED_CERT_IN_CHAIN             = 0x000004C2,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_GET_ISSUER_CERT_LOCALLY     = 0x000004C3,
    ERROR_NETWORK_MODULE_OPENSSL_X509_UNABLE_TO_VERIFY_LEAF_SIGNATURE       = 0x000004C4,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_CHAIN_TOO_LONG                   = 0x000004C5,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_REVOKED                          = 0x000004C6,
    ERROR_NETWORK_MODULE_OPENSSL_X509_INVALID_CA                            = 0x000004C7,
    ERROR_NETWORK_MODULE_OPENSSL_X509_PATH_LENGTH_EXCEEDED                  = 0x000004C8,
    ERROR_NETWORK_MODULE_OPENSSL_X509_INVALID_PURPOSE                       = 0x000004C9,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_UNTRUSTED                        = 0x000004CA,
    ERROR_NETWORK_MODULE_OPENSSL_X509_CERT_REJECTED                         = 0x000004CB,
    ERROR_NETWORK_MODULE_OPENSSL_X509_SUBJECT_ISSUER_MISMATCH               = 0x000004CC,
    ERROR_NETWORK_MODULE_OPENSSL_X509_AKID_SKID_MISMATCH                    = 0x000004CD,
    ERROR_NETWORK_MODULE_OPENSSL_X509_AKID_ISSUER_SERIAL_MISMATCH           = 0x000004CE,
    ERROR_NETWORK_MODULE_OPENSSL_X509_KEYUSAGE_NO_CERTSIGN                  = 0x000004CF,
    ERROR_NETWORK_MODULE_OPENSSL_X509_APPLICATION_VERIFICATION              = 0x000004D0,

    ERROR_NETWORK_MODULE_SCHANNEL_CANNOT_FIND_OS_VERSION                    = 0x00000514,
    ERROR_NETWORK_MODULE_SCHANNEL_OS_NOT_SUPPORTED                          = 0x00000515,
    ERROR_NETWORK_MODULE_SCHANNEL_LOADLIBRARY_FAIL                          = 0x00000516,
    ERROR_NETWORK_MODULE_SCHANNEL_CANNOT_FIND_INTERFACE                     = 0x00000517,
    ERROR_NETWORK_MODULE_SCHANNEL_INIT_FAIL                                 = 0x00000518,
    ERROR_NETWORK_MODULE_SCHANNEL_FUNCTION_CALL_FAIL                        = 0x00000519,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_UNABLE_TO_GET_ISSUER_CERT            = 0x00000546,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_TIME_INVALID                         = 0x00000547,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_SIGNATURE_INVALID                    = 0x00000548,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_UNABLE_TO_VERIFY_LEAF_SIGNATURE      = 0x00000549,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_SELF_SIGNED_LEAF_CERTIFICATE         = 0x0000054A,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_UNHANDLED_ERROR                      = 0x0000054B,
    ERROR_NETWORK_MODULE_SCHANNEL_X509_SELF_SIGNED_CERT_IN_CHAIN            = 0x0000054C,

    ERROR_WEBSOCKET_HANDSHAKE                                               = 0x00000578,

    ERROR_NETWORK_MODULE_DURANGO_UNKNOWN                                    = 0x000005DC,
    ERROR_NETWORK_MODULE_DURANGO_MALFORMED_HOST_NAME                        = 0x000005DD,
    ERROR_NETWORK_MODULE_DURANGO_INVALID_CONNECTION_RESPONSE                = 0x000005DE,
    ERROR_NETWORK_MODULE_DURANGO_INVALID_CA_CERT                            = 0x000005DF,

    ERROR_RPC_WRITE_FAILED                                                  = 0x00000BB8,
    ERROR_RPC_SERVICE_NOT_BOUND                                             = 0x00000BB9,
    ERROR_RPC_TOO_MANY_REQUESTS                                             = 0x00000BBA,
    ERROR_RPC_PEER_UNKNOWN                                                  = 0x00000BBB,
    ERROR_RPC_PEER_UNAVAILABLE                                              = 0x00000BBC,
    ERROR_RPC_PEER_DISCONNECTED                                             = 0x00000BBD,
    ERROR_RPC_REQUEST_TIMED_OUT                                             = 0x00000BBE,
    ERROR_RPC_CONNECTION_TIMED_OUT                                          = 0x00000BBF,
    ERROR_RPC_MALFORMED_RESPONSE                                            = 0x00000BC0,
    ERROR_RPC_ACCESS_DENIED                                                 = 0x00000BC1,
    ERROR_RPC_INVALID_SERVICE                                               = 0x00000BC2,
    ERROR_RPC_INVALID_METHOD                                                = 0x00000BC3,
    ERROR_RPC_INVALID_OBJECT                                                = 0x00000BC4,
    ERROR_RPC_MALFORMED_REQUEST                                             = 0x00000BC5,
    ERROR_RPC_QUOTA_EXCEEDED                                                = 0x00000BC6,
    ERROR_RPC_NOT_IMPLEMENTED                                               = 0x00000BC7,
    ERROR_RPC_SERVER_ERROR                                                  = 0x00000BC8,
    ERROR_RPC_SHUTDOWN                                                      = 0x00000BC9,
    ERROR_RPC_DISCONNECT                                                    = 0x00000BCA,
    ERROR_RPC_DISCONNECT_IDLE                                               = 0x00000BCB,
    ERROR_RPC_PROTOCOL_ERROR                                                = 0x00000BCC,
    ERROR_RPC_NOT_READY                                                     = 0x00000BCD,
    ERROR_RPC_FORWARD_FAILED                                                = 0x00000BCE,
    ERROR_RPC_ENCRYPTION_FAILED                                             = 0x00000BCF,
    ERROR_RPC_INVALID_ADDRESS                                               = 0x00000BD0,
    ERROR_RPC_METHOD_DISABLED                                               = 0x00000BD1,
    ERROR_RPC_SHARD_NOT_FOUND                                               = 0x00000BD2,
    ERROR_RPC_INVALID_CONNECTION_ID                                         = 0x00000BD3,
    ERROR_RPC_NOT_CONNECTED                                                 = 0x00000BD4,
    ERROR_RPC_INVALID_CONNECTION_STATE                                      = 0x00000BD5,
    ERROR_RPC_SERVICE_ALREADY_REGISTERED                                    = 0x00000BD6,

    ERROR_PRESENCE_INVALID_FIELD_ID                                         = 0x00000FA0,
    ERROR_PRESENCE_NO_VALID_SUBSCRIBERS                                     = 0x00000FA1,
    ERROR_PRESENCE_ALREADY_SUBSCRIBED                                       = 0x00000FA2,
    ERROR_PRESENCE_CONSUMER_NOT_FOUND                                       = 0x00000FA3,
    ERROR_PRESENCE_CONSUMER_IS_NULL                                         = 0x00000FA4,
    ERROR_PRESENCE_TEMPORARY_OUTAGE                                         = 0x00000FA5,
    ERROR_PRESENCE_TOO_MANY_SUBSCRIPTIONS                                   = 0x00000FA6,
    ERROR_PRESENCE_SUBSCRIPTION_CANCELLED                                   = 0x00000FA7,
    ERROR_PRESENCE_RICH_PRESENCE_PARSE_ERROR                                = 0x00000FA8,
    ERROR_PRESENCE_RICH_PRESENCE_XML_ERROR                                  = 0x00000FA9,
    ERROR_PRESENCE_RICH_PRESENCE_LOAD_ERROR                                 = 0x00000FAA,

    ERROR_FRIENDS_TOO_MANY_SENT_INVITATIONS                                 = 0x00001389,
    ERROR_FRIENDS_TOO_MANY_RECEIVED_INVITATIONS                             = 0x0000138A,
    ERROR_FRIENDS_FRIENDSHIP_ALREADY_EXISTS                                 = 0x0000138B,
    ERROR_FRIENDS_FRIENDSHIP_DOES_NOT_EXIST                                 = 0x0000138C,
    ERROR_FRIENDS_INVITATION_ALREADY_EXISTS                                 = 0x0000138D,
    ERROR_FRIENDS_INVALID_INVITATION                                        = 0x0000138E,
    ERROR_FRIENDS_ALREADY_SUBSCRIBED                                        = 0x0000138F,
    ERROR_FRIENDS_ACCOUNT_BLOCKED                                           = 0x00001391,
    ERROR_FRIENDS_NOT_SUBSCRIBED                                            = 0x00001392,
    ERROR_FRIENDS_INVALID_ROLE_ID                                           = 0x00001393,
    ERROR_FRIENDS_DISABLED_ROLE_ID                                          = 0x00001394,
    ERROR_FRIENDS_NOTE_MAX_SIZE_EXCEEDED                                    = 0x00001395,
    ERROR_FRIENDS_UPDATE_FRIEND_STATE_FAILED                                = 0x00001396,
    ERROR_FRIENDS_INVITEE_AT_MAX_FRIENDS                                    = 0x00001397,
    ERROR_FRIENDS_INVITER_AT_MAX_FRIENDS                                    = 0x00001398,

    ERROR_PLATFORM_STORAGE_FILE_WRITE_DENIED                                = 0x00001770,

    ERROR_WHISPER_UNDELIVERABLE                                             = 0x00001B58,
    ERROR_WHISPER_MAX_SIZE_EXCEEDED                                         = 0x00001B59,

    ERROR_USER_MANAGER_ALREADY_BLOCKED                                      = 0x00001F40,
    ERROR_USER_MANAGER_NOT_BLOCKED                                          = 0x00001F41,
    ERROR_USER_MANAGER_CANNOT_BLOCK_SELF                                    = 0x00001F42,
    ERROR_USER_MANAGER_ALREADY_REGISTERED                                   = 0x00001F43,
    ERROR_USER_MANAGER_NOT_REGISTERED                                       = 0x00001F44,
    ERROR_USER_MANAGER_TOO_MANY_BLOCKED_ENTITIES                            = 0x00001F45,
    ERROR_USER_MANAGER_TOO_MANY_IDS                                         = 0x00001F47,
    ERROR_USER_MANAGER_BLOCK_RECORD_UNAVAILABLE                             = 0x00001F4F,
    ERROR_USER_MANAGER_BLOCK_ENTITY_FAILED                                  = 0x00001F50,
    ERROR_USER_MANAGER_UNBLOCK_ENTITY_FAILED                                = 0x00001F51,
    ERROR_USER_MANAGER_CANNOT_BLOCK_FRIEND                                  = 0x00001F53,

    ERROR_SOCIAL_NETWORK_DB_EXCEPTION                                       = 0x00002328,
    ERROR_SOCIAL_NETWORK_DENIAL_FROM_PROVIDER                               = 0x00002329,
    ERROR_SOCIAL_NETWORK_INVALID_SNS_ID                                     = 0x0000232A,
    ERROR_SOCIAL_NETWORK_CANT_SEND_TO_PROVIDER                              = 0x0000232B,
    ERROR_SOCIAL_NETWORK_EX_COMM_FAILED                                     = 0x0000232C,
    ERROR_SOCIAL_NETWORK_DISABLED                                           = 0x0000232D,
    ERROR_SOCIAL_NETWORK_MISSING_REQUEST_PARAM                              = 0x0000232E,
    ERROR_SOCIAL_NETWORK_UNSUPPORTED_OAUTH_VERSION                          = 0x0000232F,

    ERROR_CHANNEL_FULL                                                      = 0x00002710,
    ERROR_CHANNEL_NO_CHANNEL                                                = 0x00002711,
    ERROR_CHANNEL_NOT_MEMBER                                                = 0x00002712,
    ERROR_CHANNEL_ALREADY_MEMBER                                            = 0x00002713,
    ERROR_CHANNEL_NO_SUCH_MEMBER                                            = 0x00002714,
    ERROR_CHANNEL_INVALID_CHANNEL_ID                                        = 0x00002716,
    ERROR_CHANNEL_NO_SUCH_INVITATION                                        = 0x00002718,
    ERROR_CHANNEL_TOO_MANY_INVITATIONS                                      = 0x00002719,
    ERROR_CHANNEL_INVITATION_ALREADY_EXISTS                                 = 0x0000271A,
    ERROR_CHANNEL_INVALID_CHANNEL_SIZE                                      = 0x0000271B,
    ERROR_CHANNEL_INVALID_ROLE_ID                                           = 0x0000271C,
    ERROR_CHANNEL_ROLE_NOT_ASSIGNABLE                                       = 0x0000271D,
    ERROR_CHANNEL_INSUFFICIENT_PRIVILEGES                                   = 0x0000271E,
    ERROR_CHANNEL_INSUFFICIENT_PRIVACY_LEVEL                                = 0x0000271F,
    ERROR_CHANNEL_INVALID_PRIVACY_LEVEL                                     = 0x00002720,
    ERROR_CHANNEL_TOO_MANY_CHANNELS_JOINED                                  = 0x00002721,
    ERROR_CHANNEL_INVITATION_ALREADY_SUBSCRIBED                             = 0x00002722,
    ERROR_CHANNEL_INVALID_CHANNEL_DELEGATE                                  = 0x00002723,
    ERROR_CHANNEL_SLOT_ALREADY_RESERVED                                     = 0x00002724,
    ERROR_CHANNEL_SLOT_NOT_RESERVED                                         = 0x00002725,
    ERROR_CHANNEL_NO_RESERVED_SLOTS_AVAILABLE                               = 0x00002726,
    ERROR_CHANNEL_INVALID_ROLE_SET                                          = 0x00002727,
    ERROR_CHANNEL_REQUIRE_FRIEND_VALIDATION                                 = 0x00002728,
    ERROR_CHANNEL_MEMBER_OFFLINE                                            = 0x00002729,
    ERROR_CHANNEL_RECEIVED_TOO_MANY_INVITATIONS                             = 0x0000272A,
    ERROR_CHANNEL_INVITATION_INVALID_GAME_ACCOUNT_SELECTED                  = 0x0000272B,
    ERROR_CHANNEL_UNREACHABLE                                               = 0x0000272C,
    ERROR_CHANNEL_INVITATION_NOT_SUBSCRIBED                                 = 0x0000272D,
    ERROR_CHANNEL_INVALID_MESSAGE_SIZE                                      = 0x0000272E,
    ERROR_CHANNEL_MAX_MESSAGE_SIZE_EXCEEDED                                 = 0x0000272F,
    ERROR_CHANNEL_CONFIG_NOT_FOUND                                          = 0x00002730,
    ERROR_CHANNEL_INVALID_CHANNEL_TYPE                                      = 0x00002731,

    ERROR_LOCAL_STORAGE_FILE_OPEN_ERROR                                     = 0x00002AF8,
    ERROR_LOCAL_STORAGE_FILE_CREATE_ERROR                                   = 0x00002AF9,
    ERROR_LOCAL_STORAGE_FILE_READ_ERROR                                     = 0x00002AFA,
    ERROR_LOCAL_STORAGE_FILE_WRITE_ERROR                                    = 0x00002AFB,
    ERROR_LOCAL_STORAGE_FILE_DELETE_ERROR                                   = 0x00002AFC,
    ERROR_LOCAL_STORAGE_FILE_COPY_ERROR                                     = 0x00002AFD,
    ERROR_LOCAL_STORAGE_FILE_DECOMPRESS_ERROR                               = 0x00002AFE,
    ERROR_LOCAL_STORAGE_FILE_HASH_MISMATCH                                  = 0x00002AFF,
    ERROR_LOCAL_STORAGE_FILE_USAGE_MISMATCH                                 = 0x00002B00,
    ERROR_LOCAL_STORAGE_DATABASE_INIT_ERROR                                 = 0x00002B01,
    ERROR_LOCAL_STORAGE_DATABASE_NEEDS_REBUILD                              = 0x00002B02,
    ERROR_LOCAL_STORAGE_DATABASE_INSERT_ERROR                               = 0x00002B03,
    ERROR_LOCAL_STORAGE_DATABASE_LOOKUP_ERROR                               = 0x00002B04,
    ERROR_LOCAL_STORAGE_DATABASE_UPDATE_ERROR                               = 0x00002B05,
    ERROR_LOCAL_STORAGE_DATABASE_DELETE_ERROR                               = 0x00002B06,
    ERROR_LOCAL_STORAGE_DATABASE_SHRINK_ERROR                               = 0x00002B07,
    ERROR_LOCAL_STORAGE_CACHE_CRAWL_ERROR                                   = 0x00002B08,
    ERROR_LOCAL_STORAGE_DATABASE_INDEX_TRIGGER_ERROR                        = 0x00002B09,
    ERROR_LOCAL_STORAGE_DATABASE_REBUILD_IN_PROGRESS                        = 0x00002B0A,
    ERROR_LOCAL_STORAGE_OK_BUT_NOT_IN_CACHE                                 = 0x00002B0B,
    ERROR_LOCAL_STORAGE_DATABASE_REBUILD_INTERRUPTED                        = 0x00002B0D,
    ERROR_LOCAL_STORAGE_DATABASE_NOT_INITIALIZED                            = 0x00002B0E,
    ERROR_LOCAL_STORAGE_DIRECTORY_CREATE_ERROR                              = 0x00002B0F,
    ERROR_LOCAL_STORAGE_FILEKEY_NOT_FOUND                                   = 0x00002B10,
    ERROR_LOCAL_STORAGE_NOT_AVAILABLE_ON_SERVER                             = 0x00002B11,

    ERROR_REGISTRY_CREATE_KEY_ERROR                                         = 0x00002EE0,
    ERROR_REGISTRY_OPEN_KEY_ERROR                                           = 0x00002EE1,
    ERROR_REGISTRY_READ_ERROR                                               = 0x00002EE2,
    ERROR_REGISTRY_WRITE_ERROR                                              = 0x00002EE3,
    ERROR_REGISTRY_TYPE_ERROR                                               = 0x00002EE4,
    ERROR_REGISTRY_DELETE_ERROR                                             = 0x00002EE5,
    ERROR_REGISTRY_ENCRYPT_ERROR                                            = 0x00002EE6,
    ERROR_REGISTRY_DECRYPT_ERROR                                            = 0x00002EE7,
    ERROR_REGISTRY_KEY_SIZE_ERROR                                           = 0x00002EE8,
    ERROR_REGISTRY_VALUE_SIZE_ERROR                                         = 0x00002EE9,
    ERROR_REGISTRY_NOT_FOUND                                                = 0x00002EEB,
    ERROR_REGISTRY_MALFORMED_STRING                                         = 0x00002EEC,

    ERROR_INTERFACE_ALREADY_CONNECTED                                       = 0x000032C8,
    ERROR_INTERFACE_NOT_READY                                               = 0x000032C9,
    ERROR_INTERFACE_OPTION_KEY_TOO_LARGE                                    = 0x000032CA,
    ERROR_INTERFACE_OPTION_VALUE_TOO_LARGE                                  = 0x000032CB,
    ERROR_INTERFACE_OPTION_KEY_INVALID_UTF8_STRING                          = 0x000032CC,
    ERROR_INTERFACE_OPTION_VALUE_INVALID_UTF8_STRING                        = 0x000032CD,

    ERROR_HTTP_COULDNT_RESOLVE                                              = 0x000036B0,
    ERROR_HTTP_COULDNT_CONNECT                                              = 0x000036B1,
    ERROR_HTTP_TIMEOUT                                                      = 0x000036B2,
    ERROR_HTTP_FAILED                                                       = 0x000036B3,
    ERROR_HTTP_MALFORMED_URL                                                = 0x000036B4,
    ERROR_HTTP_DOWNLOAD_ABORTED                                             = 0x000036B5,
    ERROR_HTTP_COULDNT_WRITE_FILE                                           = 0x000036B6,
    ERROR_HTTP_TOO_MANY_REDIRECTS                                           = 0x000036B7,
    ERROR_HTTP_COULDNT_OPEN_FILE                                            = 0x000036B8,
    ERROR_HTTP_COULDNT_CREATE_FILE                                          = 0x000036B9,
    ERROR_HTTP_COULDNT_READ_FILE                                            = 0x000036BA,
    ERROR_HTTP_COULDNT_RENAME_FILE                                          = 0x000036BB,
    ERROR_HTTP_COULDNT_CREATE_DIRECTORY                                     = 0x000036BC,
    ERROR_HTTP_CURL_IS_NOT_READY                                            = 0x000036BD,
    ERROR_HTTP_CANCELLED                                                    = 0x000036BE,

    ERROR_HTTP_FILE_NOT_FOUND                                               = 0x00003844,

    ERROR_ACCOUNT_MISSING_CONFIG                                            = 0x00004650,
    ERROR_ACCOUNT_DATA_NOT_FOUND                                            = 0x00004651,
    ERROR_ACCOUNT_ALREADY_SUBSCRIBED                                        = 0x00004652,
    ERROR_ACCOUNT_NOT_SUBSCRIBED                                            = 0x00004653,
    ERROR_ACCOUNT_FAILED_TO_PARSE_TIMEZONE_DATA                             = 0x00004654,
    ERROR_ACCOUNT_LOAD_FAILED                                               = 0x00004655,
    ERROR_ACCOUNT_LOAD_CANCELLED                                            = 0x00004656,
    ERROR_ACCOUNT_DATABASE_INVALIDATE_FAILED                                = 0x00004657,
    ERROR_ACCOUNT_CACHE_INVALIDATE_FAILED                                   = 0x00004658,
    ERROR_ACCOUNT_SUBSCRIPTION_PENDING                                      = 0x00004659,
    ERROR_ACCOUNT_UNKNOWN_REGION                                            = 0x0000465A,
    ERROR_ACCOUNT_DATA_FAILED_TO_PARSE                                      = 0x0000465B,
    ERROR_ACCOUNT_UNDERAGE                                                  = 0x0000465C,
    ERROR_ACCOUNT_IDENTITY_CHECK_PENDING                                    = 0x0000465D,
    ERROR_ACCOUNT_IDENTITY_UNVERIFIED                                       = 0x0000465E,

    ERROR_DATABASE_BINDING_COUNT_MISMATCH                                   = 0x00004A38,
    ERROR_DATABASE_BINDING_PARSE_FAIL                                       = 0x00004A39,
    ERROR_DATABASE_RESULTSET_COLUMNS_MISMATCH                               = 0x00004A3A,
    ERROR_DATABASE_DEADLOCK                                                 = 0x00004A3B,
    ERROR_DATABASE_DUPLICATE_KEY                                            = 0x00004A3C,
    ERROR_DATABASE_CANNOT_CONNECT                                           = 0x00004A3D,
    ERROR_DATABASE_STATEMENT_FAILED                                         = 0x00004A3E,
    ERROR_DATABASE_TRANSACTION_NOT_STARTED                                  = 0x00004A3F,
    ERROR_DATABASE_TRANSACTION_NOT_ENDED                                    = 0x00004A40,
    ERROR_DATABASE_TRANSACTION_LEAK                                         = 0x00004A41,
    ERROR_DATABASE_TRANSACTION_STATE_BAD                                    = 0x00004A42,
    ERROR_DATABASE_SERVER_GONE                                              = 0x00004A43,
    ERROR_DATABASE_QUERY_TIMEOUT                                            = 0x00004A44,
    ERROR_DATABASE_BINDING_NOT_NULLABLE                                     = 0x00004A9C,
    ERROR_DATABASE_BINDING_INVALID_INTEGER                                  = 0x00004A9D,
    ERROR_DATABASE_BINDING_INVALID_FLOAT                                    = 0x00004A9E,
    ERROR_DATABASE_BINDING_INVALID_TEMPORAL                                 = 0x00004A9F,
    ERROR_DATABASE_BINDING_INVALID_PROTOBUF                                 = 0x00004AA0,

    ERROR_PARTY_INVALID_PARTY_ID                                            = 0x00004E20,
    ERROR_PARTY_ALREADY_IN_PARTY                                            = 0x00004E21,
    ERROR_PARTY_NOT_IN_PARTY                                                = 0x00004E22,
    ERROR_PARTY_INVITATION_UNDELIVERABLE                                    = 0x00004E23,
    ERROR_PARTY_INVITATION_ALREADY_EXISTS                                   = 0x00004E24,
    ERROR_PARTY_TOO_MANY_PARTY_INVITATIONS                                  = 0x00004E25,
    ERROR_PARTY_TOO_MANY_RECEIVED_INVITATIONS                               = 0x00004E26,
    ERROR_PARTY_NO_SUCH_TYPE                                                = 0x00004E27,

    ERROR_GAMES_NO_SUCH_FACTORY                                             = 0x000055F0,
    ERROR_GAMES_NO_SUCH_GAME                                                = 0x000055F1,
    ERROR_GAMES_NO_SUCH_REQUEST                                             = 0x000055F2,
    ERROR_GAMES_NO_SUCH_PARTY_MEMBER                                        = 0x000055F3,

    ERROR_RESOURCES_OFFLINE                                                 = 0x000059D8,

    ERROR_GAME_SERVER_CREATE_GAME_REFUSED                                   = 0x00005DC0,
    ERROR_GAME_SERVER_ADD_PLAYERS_REFUSED                                   = 0x00005DC1,
    ERROR_GAME_SERVER_REMOVE_PLAYERS_REFUSED                                = 0x00005DC2,
    ERROR_GAME_SERVER_FINISH_GAME_REFUSED                                   = 0x00005DC3,
    ERROR_GAME_SERVER_NO_SUCH_GAME                                          = 0x00005DC4,
    ERROR_GAME_SERVER_NO_SUCH_PLAYER                                        = 0x00005DC5,
    ERROR_GAME_SERVER_CREATE_GAME_REFUSED_TRANSIENT                         = 0x00005DF2,
    ERROR_GAME_SERVER_ADD_PLAYERS_REFUSED_TRANSIENT                         = 0x00005DF3,
    ERROR_GAME_SERVER_REMOVE_PLAYERS_REFUSED_TRANSIENT                      = 0x00005DF4,
    ERROR_GAME_SERVER_FINISH_GAME_REFUSED_TRANSIENT                         = 0x00005DF5,
    ERROR_GAME_SERVER_CREATE_GAME_REFUSED_BUSY                              = 0x00005E24,
    ERROR_GAME_SERVER_ADD_PLAYERS_REFUSED_BUSY                              = 0x00005E25,
    ERROR_GAME_SERVER_REMOVE_PLAYERS_REFUSED_BUSY                           = 0x00005E26,
    ERROR_GAME_SERVER_FINISH_GAME_REFUSED_BUSY                              = 0x00005E27,

    ERROR_GAME_MASTER_INVALID_FACTORY                                       = 0x000061A8,
    ERROR_GAME_MASTER_INVALID_GAME                                          = 0x000061A9,
    ERROR_GAME_MASTER_GAME_FULL                                             = 0x000061AA,
    ERROR_GAME_MASTER_REGISTER_FAILED                                       = 0x000061AB,
    ERROR_GAME_MASTER_NO_GAME_SERVER                                        = 0x000061AC,
    ERROR_GAME_MASTER_NO_UTILITY_SERVER                                     = 0x000061AD,
    ERROR_GAME_MASTER_NO_GAME_VERSION                                       = 0x000061AE,
    ERROR_GAME_MASTER_GAME_JOIN_FAILED                                      = 0x000061AF,
    ERROR_GAME_MASTER_ALREADY_REGISTERED                                    = 0x000061B0,
    ERROR_GAME_MASTER_NO_FACTORY                                            = 0x000061B1,
    ERROR_GAME_MASTER_MULTIPLE_GAME_VERSIONS                                = 0x000061B2,
    ERROR_GAME_MASTER_INVALID_PLAYER                                        = 0x000061B3,
    ERROR_GAME_MASTER_INVALID_GAME_REQUEST                                  = 0x000061B4,
    ERROR_GAME_MASTER_INSUFFICIENT_PRIVILEGES                               = 0x000061B5,
    ERROR_GAME_MASTER_ALREADY_IN_GAME                                       = 0x000061B6,
    ERROR_GAME_MASTER_INVALID_GAME_SERVER_RESPONSE                          = 0x000061B7,
    ERROR_GAME_MASTER_GAME_ACCOUNT_LOOKUP_FAILED                            = 0x000061B8,
    ERROR_GAME_MASTER_GAME_ENTRY_CANCELLED                                  = 0x000061B9,
    ERROR_GAME_MASTER_GAME_ENTRY_ABORTED_CLIENT_DROPPED                     = 0x000061BA,
    ERROR_GAME_MASTER_GAME_ENTRY_ABORTED_BY_SERVICE                         = 0x000061BB,
    ERROR_GAME_MASTER_NO_AVAILABLE_CAPACITY                                 = 0x000061BC,
    ERROR_GAME_MASTER_INVALID_TEAM_ID                                       = 0x000061BD,
    ERROR_GAME_MASTER_CREATION_IN_PROGRESS                                  = 0x000061BE,

    ERROR_NOTIFICATION_INVALID_CLIENT_ID                                    = 0x00006590,
    ERROR_NOTIFICATION_DUPLICATE_NAME                                       = 0x00006591,
    ERROR_NOTIFICATION_NAME_NOT_FOUND                                       = 0x00006592,
    ERROR_NOTIFICATION_INVALID_SERVER                                       = 0x00006593,
    ERROR_NOTIFICATION_QUOTA_EXCEEDED                                       = 0x00006594,
    ERROR_NOTIFICATION_INVALID_NOTIFICATION_TYPE                            = 0x00006595,
    ERROR_NOTIFICATION_UNDELIVERABLE                                        = 0x00006596,
    ERROR_NOTIFICATION_UNDELIVERABLE_TEMPORARY                              = 0x00006597,

    ERROR_ACHIEVEMENTS_NOTHING_TO_UPDATE                                    = 0x00006D60,
    ERROR_ACHIEVEMENTS_INVALID_PARAMS                                       = 0x00006D61,
    ERROR_ACHIEVEMENTS_NOT_REGISTERED                                       = 0x00006D62,
    ERROR_ACHIEVEMENTS_NOT_READY                                            = 0x00006D63,
    ERROR_ACHIEVEMENTS_FAILED_TO_PARSE_STATIC_DATA                          = 0x00006D64,
    ERROR_ACHIEVEMENTS_UNKNOWN_ID                                           = 0x00006D65,
    ERROR_ACHIEVEMENTS_MISSING_SNAPSHOT                                     = 0x00006D66,
    ERROR_ACHIEVEMENTS_ALREADY_REGISTERED                                   = 0x00006D67,
    ERROR_ACHIEVEMENTS_TOO_MANY_REGISTRATIONS                               = 0x00006D68,
    ERROR_ACHIEVEMENTS_ALREADY_IN_PROGRESS                                  = 0x00006D69,
    ERROR_ACHIEVEMENTS_TEMPORARY_OUTAGE                                     = 0x00006D6A,
    ERROR_ACHIEVEMENTS_INVALID_PROGRAMID                                    = 0x00006D6B,
    ERROR_ACHIEVEMENTS_MISSING_RECORD                                       = 0x00006D6C,
    ERROR_ACHIEVEMENTS_REGISTRATION_PENDING                                 = 0x00006D6D,
    ERROR_ACHIEVEMENTS_ENTITY_ID_NOT_FOUND                                  = 0x00006D6E,
    ERROR_ACHIEVEMENTS_ACHIEVEMENT_ID_NOT_FOUND                             = 0x00006D6F,
    ERROR_ACHIEVEMENTS_CRITERIA_ID_NOT_FOUND                                = 0x00006D70,
    ERROR_ACHIEVEMENTS_STATIC_DATA_MISMATCH                                 = 0x00006D71,
    ERROR_ACHIEVEMENTS_WRONG_THREAD                                         = 0x00006D72,
    ERROR_ACHIEVEMENTS_CALLBACK_IS_NULL                                     = 0x00006D73,
    ERROR_ACHIEVEMENTS_AUTO_REGISTER_PENDING                                = 0x00006D74,
    ERROR_ACHIEVEMENTS_NOT_INITIALIZED                                      = 0x00006D75,
    ERROR_ACHIEVEMENTS_ACHIEVEMENT_ID_ALREADY_EXISTS                        = 0x00006D76,
    ERROR_ACHIEVEMENTS_FAILED_TO_DOWNLOAD_STATIC_DATA                       = 0x00006D77,
    ERROR_ACHIEVEMENTS_STATIC_DATA_NOT_FOUND                                = 0x00006D78,

    ERROR_GAME_UTILITY_SERVER_VARIABLE_REQUEST_REFUSED                      = 0x000084D1,
    ERROR_GAME_UTILITY_SERVER_WRONG_NUMBER_OF_VARIABLES_RETURNED            = 0x000084D2,
    ERROR_GAME_UTILITY_SERVER_CLIENT_REQUEST_REFUSED                        = 0x000084D3,
    ERROR_GAME_UTILITY_SERVER_PRESENCE_CHANNEL_CREATED_REFUSED              = 0x000084D4,
    ERROR_GAME_UTILITY_SERVER_VARIABLE_REQUEST_REFUSED_TRANSIENT            = 0x00008502,
    ERROR_GAME_UTILITY_SERVER_CLIENT_REQUEST_REFUSED_TRANSIENT              = 0x00008503,
    ERROR_GAME_UTILITY_SERVER_PRESENCE_CHANNEL_CREATED_REFUSED_TRANSIENT    = 0x00008504,
    ERROR_GAME_UTILITY_SERVER_SERVER_REQUEST_REFUSED_TRANSIENT              = 0x00008505,
    ERROR_GAME_UTILITY_SERVER_VARIABLE_REQUEST_REFUSED_BUSY                 = 0x00008534,
    ERROR_GAME_UTILITY_SERVER_CLIENT_REQUEST_REFUSED_BUSY                   = 0x00008535,
    ERROR_GAME_UTILITY_SERVER_PRESENCE_CHANNEL_CREATED_REFUSED_BUSY         = 0x00008536,
    ERROR_GAME_UTILITY_SERVER_SERVER_REQUEST_REFUSED_BUSY                   = 0x00008537,
    ERROR_GAME_UTILITY_SERVER_NO_SERVER                                     = 0x00008598,

    ERROR_IDENTITY_INSUFFICIENT_DATA                                        = 0x0000A028,
    ERROR_IDENTITY_TOO_MANY_RESULTS                                         = 0x0000A029,
    ERROR_IDENTITY_BAD_ID                                                   = 0x0000A02A,
    ERROR_IDENTITY_NO_ACCOUNT_BLOB                                          = 0x0000A02B,

    ERROR_RISK_CHALLENGE_ACTION                                             = 0x0000A410,
    ERROR_RISK_DELAY_ACTION                                                 = 0x0000A411,
    ERROR_RISK_THROTTLE_ACTION                                              = 0x0000A412,
    ERROR_RISK_ACCOUNT_LOCKED                                               = 0x0000A413,
    ERROR_RISK_CS_DENIED                                                    = 0x0000A414,
    ERROR_RISK_DISCONNECT_ACCOUNT                                           = 0x0000A415,
    ERROR_RISK_CHECK_SKIPPED                                                = 0x0000A416,

    ERROR_REPORT_UNAVAILABLE                                                = 0x0000AFC8,
    ERROR_REPORT_TOO_LARGE                                                  = 0x0000AFC9,
    ERROR_REPORT_UNKNOWN_TYPE                                               = 0x0000AFCA,
    ERROR_REPORT_ATTRIBUTE_INVALID                                          = 0x0000AFCB,
    ERROR_REPORT_ATTRIBUTE_QUOTA_EXCEEDED                                   = 0x0000AFCC,
    ERROR_REPORT_UNCONFIRMED                                                = 0x0000AFCD,
    ERROR_REPORT_NOT_CONNECTED                                              = 0x0000AFCE,
    ERROR_REPORT_REJECTED                                                   = 0x0000AFCF,
    ERROR_REPORT_TOO_MANY_REQUESTS                                          = 0x0000AFD0,

    ERROR_ACCOUNT_ALREADY_REGISTERD                                         = 0x0000BB80,
    ERROR_ACCOUNT_NOT_REGISTERED                                            = 0x0000BB81,
    ERROR_ACCOUNT_REGISTRATION_PENDING                                      = 0x0000BB82,

    ERROR_MEMCACHED_CLIENT_NO_ERROR                                         = 0x00010000,
    ERROR_MEMCACHED_CLIENT_KEY_NOT_FOUND                                    = 0x00010001,
    ERROR_MEMCACHED_KEY_EXISTS                                              = 0x00010002,
    ERROR_MEMCACHED_VALUE_TO_LARGE                                          = 0x00010003,
    ERROR_MEMCACHED_INVALID_ARGS                                            = 0x00010004,
    ERROR_MEMCACHED_ITEM_NOT_STORED                                         = 0x00010005,
    ERROR_MEMCACHED_NON_NUMERIC_VALUE                                       = 0x00010006,
    ERROR_MEMCACHED_WRONG_SERVER                                            = 0x00010007,
    ERROR_MEMCACHED_AUTHENTICATION_ERROR                                    = 0x00010008,
    ERROR_MEMCACHED_AUTHENTICATION_CONTINUE                                 = 0x00010009,
    ERROR_MEMCACHED_UNKNOWN_COMMAND                                         = 0x0001000A,
    ERROR_MEMCACHED_OUT_OF_MEMORY                                           = 0x0001000B,
    ERROR_MEMCACHED_NOT_SUPPORTED                                           = 0x0001000C,
    ERROR_MEMCACHED_INTERNAL_ERROR                                          = 0x0001000D,
    ERROR_MEMCACHED_TEMPORARY_FAILURE                                       = 0x0001000E,

    ERROR_MEMCACHED_CLIENT_ALREADY_CONNECTED                                = 0x000186A0,
    ERROR_MEMCACHED_CLIENT_BAD_CONFIG                                       = 0x000186A1,
    ERROR_MEMCACHED_CLIENT_NOT_CONNECTED                                    = 0x000186A2,
    ERROR_MEMCACHED_CLIENT_TIMEOUT                                          = 0x000186A3,
    ERROR_MEMCACHED_CLIENT_ABORTED                                          = 0x000186A4,

    ERROR_UTIL_SERVER_FAILED_TO_SERIALIZE                                   = 0x80000064,
    ERROR_UTIL_SERVER_DISCONNECTED_FROM_BATTLENET                           = 0x80000065,
    ERROR_UTIL_SERVER_TIMED_OUT                                             = 0x80000066,
    ERROR_UTIL_SERVER_NO_METERING_DATA                                      = 0x80000067,
    ERROR_UTIL_SERVER_FAIL_PERMISSION_CHECK                                 = 0x80000068,
    ERROR_UTIL_SERVER_UNKNOWN_REALM                                         = 0x80000069,
    ERROR_UTIL_SERVER_MISSING_SESSION_KEY                                   = 0x8000006A,
    ERROR_UTIL_SERVER_MISSING_VIRTUAL_REALM                                 = 0x8000006B,
    ERROR_UTIL_SERVER_INVALID_SESSION_KEY                                   = 0x8000006C,
    ERROR_UTIL_SERVER_MISSING_REALM_LIST                                    = 0x8000006D,
    ERROR_UTIL_SERVER_INVALID_IDENTITY_ARGS                                 = 0x8000006E,
    ERROR_UTIL_SERVER_SESSION_OBJECT_MISSING                                = 0x8000006F,
    ERROR_UTIL_SERVER_INVALID_BNET_SESSION                                  = 0x80000070,
    ERROR_UTIL_SERVER_INVALID_VIRTUAL_REALM                                 = 0x80000071,
    ERROR_UTIL_SERVER_INVALID_CLIENT_ADDRESS                                = 0x80000072,
    ERROR_UTIL_SERVER_FAILED_TO_SERIALIZE_RESPONSE                          = 0x80000073,
    ERROR_UTIL_SERVER_UNKNOWN_REQUEST                                       = 0x80000074,
    ERROR_UTIL_SERVER_UNABLE_TO_GENERATE_JOIN_TICKET                        = 0x80000075,
    ERROR_UTIL_SERVER_UNABLE_TO_GENERATE_REALM_LIST_TICKET                  = 0x80000076,
    ERROR_UTIL_SERVER_ACCOUNT_DENIED                                        = 0x80000077,
    ERROR_UTIL_SERVER_INVALID_WOW_ACCOUNT                                   = 0x80000078,
    ERROR_UTIL_SERVER_UNABLE_TO_STORE_SESSION                               = 0x80000079,
    ERROR_UTIL_SERVER_SESSION_ALREADY_CREATED                               = 0x8000007A,

    ERROR_USER_SERVER_FAILED_TO_SERIALIZE                                   = 0x800000C8,
    ERROR_USER_SERVER_DISCONNECTED_FROM_UTIL                                = 0x800000C9,
    ERROR_USER_SERVER_SESSION_DUPLICATE                                     = 0x800000CA,
    ERROR_USER_SERVER_FAILED_TO_DISABLE_BILLING                             = 0x800000CB,
    ERROR_USER_SERVER_PLAYER_DISCONNECTED                                   = 0x800000CC,
    ERROR_USER_SERVER_FAILED_TO_PARSE_ACCOUNT_STATE                         = 0x800000CD,
    ERROR_USER_SERVER_ACCOUNT_LOAD_CANCELLED                                = 0x800000CE,
    ERROR_USER_SERVER_BAD_PLATFORM                                          = 0x800000CF,
    ERROR_USER_SERVER_BAD_VIRTUAL_REALM                                     = 0x800000D0,
    ERROR_USER_SERVER_LOCALE_RESTRICTED                                     = 0x800000D1,
    ERROR_USER_SERVER_MISSING_PROPASS                                       = 0x800000D2,
    ERROR_USER_SERVER_BAD_WOW_ACCOUNT                                       = 0x800000D3,
    ERROR_USER_SERVER_BAD_BNET_ACCOUNT                                      = 0x800000D4,
    ERROR_USER_SERVER_FAILED_TO_PARSE_GAME_ACCOUNT_STATE                    = 0x800000D5,
    ERROR_USER_SERVER_FAILED_TO_PARSE_GAME_TIME_REMAINING                   = 0x800000D6,
    ERROR_USER_SERVER_FAILED_TO_PARSE_GAME_SESSION_INFO                     = 0x800000D7,
    ERROR_USER_SERVER_ACCOUNT_STATE_POORLY_FORMED                           = 0x800000D8,
    ERROR_USER_SERVER_GAME_ACCOUNT_STATE_POORLY_FORMED                      = 0x800000D9,
    ERROR_USER_SERVER_GAME_TIME_REMAINING_POORLY_FORMED                     = 0x800000DA,
    ERROR_USER_SERVER_GAME_SESSION_INFO_POORLY_FORMED                       = 0x800000DB,
    ERROR_USER_SERVER_BAD_SESSION_TRACKER_STATE                             = 0x800000DC,
    ERROR_USER_SERVER_FAILED_TO_PARSE_CAIS_INFO                             = 0x800000DD,
    ERROR_USER_SERVER_GAME_SESSION_DISCONNECTED                             = 0x800000DE,
    ERROR_USER_SERVER_VERSION_MISMATCH                                      = 0x800000DF,
    ERROR_USER_SERVER_ACCOUNT_SUSPENDED                                     = 0x800000E0,
    ERROR_USER_SERVER_NOT_PERMITTED_ON_REALM                                = 0x800000E1,
    ERROR_USER_SERVER_LOGIN_FAILED_CONNECT                                  = 0x800000E2,

    ERROR_WOW_SERVICES_TIMED_OUT                                            = 0x8000012C,
    ERROR_WOW_SERVICES_INVALID_REALM_LIST_TICKET                            = 0x8000012D,
    ERROR_WOW_SERVICES_INVALID_JOIN_TICKET                                  = 0x8000012E,
    ERROR_WOW_SERVICES_INVALID_SERVER_ADDRESSES                             = 0x8000012F,
    ERROR_WOW_SERVICES_INVALID_SECRET_BLOB                                  = 0x80000130,
    ERROR_WOW_SERVICES_NO_REALM_JOIN_IP_FOUND                               = 0x80000131,
    ERROR_WOW_SERVICES_DENIED_REALM_LIST_TICKET                             = 0x80000132,
    ERROR_WOW_SERVICES_MISSING_GAME_ACCOUNT                                 = 0x80000133,
    ERROR_WOW_SERVICES_LOGON_INVALID_AUTH_TOKEN                             = 0x80000134,
    ERROR_WOW_SERVICES_NO_AVAILABLE_REALMS                                  = 0x80000135,
    ERROR_WOW_SERVICES_FAILED_TO_PARSE_DISPATCH                             = 0x80000136,
    ERROR_WOW_SERVICES_MISSING_METERING_FILE                                = 0x80000137,
    ERROR_WOW_SERVICES_LOGIN_INVALID_CONTENT_TYPE                           = 0x80000138,
    ERROR_WOW_SERVICES_LOGIN_UNABLE_TO_DECODE                               = 0x80000139,
    ERROR_WOW_SERVICES_LOGIN_POST_ERROR                                     = 0x8000013A,
    ERROR_WOW_SERVICES_AUTHENTICATOR_PARSE_FAILED                           = 0x8000013B,
    ERROR_WOW_SERVICES_LEGAL_PARSE_FAILED                                   = 0x8000013C,
    ERROR_WOW_SERVICES_LOGIN_AUTHENTICATION_PARSE_FAILED                    = 0x8000013D,
    ERROR_WOW_SERIVCES_USER_MUST_ACCEPT_LEGAL                               = 0x8000013E,
    ERROR_WOW_SERVICES_DISCONNECTED                                         = 0x8000013F,
    ERROR_WOW_SERVICES_NO_HANDLER_FOR_DISPATCH                              = 0x80000140,
    ERROR_WOW_SERVICES_PRE_DISPATCH_HANDLER_FAILED                          = 0x80000141,
    ERROR_WOW_SERVICES_CRITICAL_STREAMING_ERROR                             = 0x80000142,
    ERROR_WOW_SERVICES_WORLD_LOAD_ERROR                                     = 0x80000143,
    ERROR_WOW_SERVICES_LOGIN_FAILED                                         = 0x80000144,
    ERROR_WOW_SERVICES_LOGIN_FAILED_ON_CHALLENGE                            = 0x80000145,
    ERROR_WOW_SERVICES_NO_PREPAID_TIME                                      = 0x80000146,
    ERROR_WOW_SERVICES_SUBSCRIPTION_EXPIRED                                 = 0x80000147,
    ERROR_WOW_SERVICES_CANT_CONNECT                                         = 0x80000148,
};
#endif // BattlenetRpcErrorCodes_h__
