//// MxWoW Official Module
//// Level Up
//// Dev:       mikx
//// Git:       https://mxgit.ovh/MxWoW/mod_mxwow_levelup

#include "Configuration/Config.h"
#include "ScriptMgr.h"
#include "Player.h"
#include "Chat.h"

class mod_mxw_levelup : public PlayerScript
{

public:

    mod_mxw_levelup() : PlayerScript("mod_mxw_levelup") { }

    void OnLogin(Player* player) override
    {
        ChatHandler(player->GetSession()).SendSysMessage("This server is running the |cff4CFF00MxW Level Up |rscript.");
    }

    void OnLevelChanged(Player * player, uint8 oldLevel)
    {
        Map* map = player->GetMap();
        std::string mapName = map->GetMapName();
        std::ostringstream ss;
        if (sConfigMgr->GetBoolDefault("LevelUp.Enabled", true))
        {
            ss << "|cffabeeff[MxW] [" << GetPlayerColor(player) << player->GetName() << "|cffabeeff][|cff09ff00"<< mapName <<"|cffabeeff] est maintenant niveau |cff09ff00"<< oldLevel + 1 <<"|cffabeeff.";
            sWorld->SendServerMessage(SERVER_MSG_STRING, ss.str().c_str());
        }
    }

    std::string GetPlayerColor(const Player* p)
    {
        switch (p->getClass())
        {
        case CLASS_ROGUE:
            return "|cffFFF468";
        case CLASS_DEATH_KNIGHT:
            return "|cffC41E3A";
        case CLASS_WARRIOR:
            return "|cffC69B6D";
        case CLASS_PRIEST:
            return "|cffFFFFFF";
        case CLASS_MAGE:
            return "|cff3FC7EB";
        case CLASS_PALADIN:
            return "|cffF48CBA";
        case CLASS_HUNTER:
            return "|cffAAD372";
        case CLASS_DRUID:
            return "|cffFF7C0A";
        case CLASS_SHAMAN:
            return "|cff0070DD";
        case CLASS_WARLOCK:
            return "|cff8788EE";
        case CLASS_DEMON_HUNTER:
            return "|cffA330C9";
        case CLASS_MONK:
            return "|cff00FF98";
        default:
            return "n/d";
        }
    }
};

void AddSC_mod_mxw_levelup()
{
    new mod_mxw_levelup();
}
