/* Custom Events
*/

#ifndef CUSTOM_EVENTS
#define CUSTOM_EVENTS

enum SPTemple
{
    npc_gretchen        = 150000,
    npc_candace         = 150001,
    npc_hidden_blood    = 150002,
    npc_circle_sum_eff  = 150005,
    npc_enter_ritual    = 150006,
    npc_hidden_trigg    = 150007,
    npc_skull_place     = 150008,
    npc_blood_place     = 150009,
    npc_portal2temple   = 150003,


    npc_vonjin          = 150010,
    npc_vonjin_weapon   = 150012,

    npc_lessar          = 150011,
    npc_smoothervine    = 150013,

    npc_hadorn          = 150004,
    npc_poison_ring_a   = 150017,
    npc_poison_ring_b   = 150018,
    npc_poison_ring_c   = 150019,
    npc_temple_fury_t   = 150020,
    npc_temple_fury_b   = 150026,
    npc_zandalari_priest= 150014,
    npc_venom_slayer    = 150016,
    npc_zandalari_bers  = 150015,
    npc_empowering_sph  = 150022,
    npc_spirit_first    = 150023,
    npc_spirit_4kill    = 150024,
    npc_poison_totem    = 150025,
    npc_spirit_chains   = 150021,

    go_hazorn_skull_1   = 480001,
    go_hazorn_skull_2   = 480002,
    go_ritual_blood_1   = 480003,
    go_ritual_blood_2   = 480004,

    npc_inv_init_a      = 542113,
    npc_inv_init_h      = 542114,
    npc_inv_add_s1      = 542100,
    npc_inv_add_s2      = 542101,
    npc_inv_add_s3      = 542102,
    npc_inv_add_l1      = 542118,
    npc_inv_add_l2      = 542119,
    npc_inv_add_l3      = 542105,
    npc_inv_add_l4      = 542103,
    npc_inv_add_x1      = 542104,
    npc_inv_add_x2      = 542106,
    npc_inv_commander1  = 542111,
    npc_inv_commander2  = 542112,
    npc_inv_ship_a      = 542107,
    npc_inv_ship_h      = 542110,

    npc_atray           = 542185,
    npc_atray_khadgar   = 542186,
    npc_atray_khadgar_tr= 542189,
    npc_atray_son       = 542187,
    npc_atray_blizzard  = 542188,
    npc_atray_add       = 542200,

    npc_evala           = 542191,
    npc_evala_minion    = 542190,
    npc_evala_guard     = 542192,
    npc_evala_sphere    = 542193,
    npc_evala_frostmage = 542194,
    npc_evala_frostwarr = 542195,
    npc_evala_tomb      = 542197,
    npc_evala_shard     = 542198,
    npc_evala_portal    = 542199,
    npc_evala_void_zone = 542196,
};

enum eData
{
    mapStromgard        = 1178,
    mapWarsong          = 2100,
};

std::vector<uint32> sAdds
{
    542100,
    542101,
    542102,
};

std::vector<uint32> lAdds
{
    542118,
    542119,
    542105,
    542103,
};

std::vector<uint32> xAdds
{
    542104,
    542106,
};

std::vector<uint32> cAdds
{
    542111,
    542112,
};

enum misc
{
    spirits_max         = 12,
    max_adds            = 5,
    max_spheres         = 3,
    fact_horde          = 85,
    fact_alliance       = 11,
    event_deserter      = 305227,
};

Position const spiritPos[12] = 
{ 
    { -471.37f, 123.50f, -189.729f, 5.53f},
    { -460.54f, 117.28f, -189.729f, 3.77f},
    { -479.70f, 116.77f, -189.729f, 4.68f},
    { -470.71f, 107.70f, -189.729f, 0.11f},
    { -458.86f, 102.f, -189.729f, 5.76f},
    { -459.45f, 88.62f, -189.729f, 4.54f},
    { -470.28f, 91.47f, -189.729f, 2.36f},
    { -484.78f, 97.90f, -189.729f, 2.99f},
    { -490.56f, 84.32f, -189.729f, 0.09f},
    { -477.70f, 76.18f, -189.729f, 1.27f},
    { -460.79f, 71.88f, -189.729f, 2.04f},
    { -499.69f, 108.45f, -189.729f, 3.87f},
};

Position const addsPos[5] =
{
    { -527.57f, 59.65f, -67.f, 0.51f },
    { -527.56f, 129.47f, -67.f, 5.73f },
    { -467.34f, 166.20f, -67.f, 4.71f },
    { -406.03f, 130.93f, -67.f, 3.61f },
    { -405.62f, 60.22f, -67.f, 2.5f },
};

Position const addsMove[10] =
{
    { -521.27f, 67.19f, -66.45f, 0.51f },
    { -500.16f, 79.24f, -91.24f, 0.52f },

    { -520.62f, 125.11f, -66.45f, 5.64f },
    { -499.99f, 114.53f, -91.12f, 5.81f },

    { -467.99f, 156.59f, -66.37f, 4.7f },
    { -466.45f, 132.33f, -91.21f, 4.77f },

    { -414.42f, 126.27f, -66.69f, 3.7f },
    { -436.56f, 112.52f, -91.37f, 3.68f },

    { -412.98f, 66.28f, -66.44f, 2.57f },
    { -435.97f, 77.92f, -91.33f, 2.72f },
};

Position const spherePos[3] =
{
    { -467.02f, 33.56f, -91.09f, 1.49f },
    { -418.37f, 127.97f, -91.18f, 3.65f },
    { -521.49f, 126.21f, -91.06f, 5.67f },
};

Position const skullNblood[3] =
{
    { -665.219f, 52.24f, -90.00f, 5.07f }, //skull
    { -428.89f, -86.15f, -86.90f, 3.14f },
};

Position const summonCircle = { -466.63f, 273.04f, -90.44f, 0.f };
Position const summonSkull = { -465.66f, 268.52f, -90.39f, 1.9f };
Position const summonBlood = { -468.00f, 278.00f, -90.44f, 4.85f };

Position const ritualPoints[4] =
{
    { -475.86f, 273.40f, -90.46f, 5.07f },
    { -466.92f, 264.35f, -90.41f, 3.14f },
    { -457.70f, 273.26f, -90.41f, 3.14f },
    { -466.67f, 282.26f, -90.41f, 3.14f },
};

Position const barrensLegionAddPos[34] =
{
    { -476.71f, -2699.46f, 95.1476f, 5.07f },
    { -462.791f, -2671.47f, 95.52f, 3.14f },
    { -483.043f, -2650.94f, 95.78f, 3.14f },
    { -526.26f, -2651.88f, 95.71f, 3.14f },
    { -577.59f, -2644.91f, 95.78f, 3.14f },
    { -552.93f, -2612.9f, 91.84f, 3.14f },
    { -497.71f, -2641.1f, 96.8f, 3.14f },
    { -483.92f, -2630.55f, 99.89f, 3.14f },
    { -442.87f, -2630.29f, 95.49f, 3.14f },
    { -444.11f, -2595.11f, 96.17f, 3.14f },
    { -408.99f, -2600.2f, 95.76f, 3.14f },
    { -407.99f, -2569.43f, 98.30f, 3.14f },
    { -373.04f, -2556.07f, 95.757f, 3.14f },
    { -367.96f, -2581.05f, 96.53f, 3.14f },
    { -377.14f, -2618.43f, 95.753f, 3.14f },
    { -342.01f, -2644.68f, 96.08f, 3.14f },
    { -340.81f, -2674.35f, 95.77f, 3.14f },
    { -357.48f, -2694.77f, 96.57f, 3.14f },
    { -349.43f, -2513.98f, 95.04f, 3.14f },
    { -380.57f, -2483.77f, 93.96f, 3.14f },
    { -312.00f, -2541.67f, 95.53f, 3.14f },
    { -306.742f, -2587.82f, 96.20f, 3.14f },
    { -511.87f, -2602.83f, 109.24f, 1.2f },
    { -520.04f, -2565.6f, 92.96f, 1.2f },
    { -584.11f, -2705.12f, 102.21f, 1.2f },
    { -515.32f, -2708.94f, 95.994f, 1.2f },
    { -403.88f, -2692.81f, 96.71f, 1.2f },
    { -357.26f, -2679.33f, 95.69f, 1.2f },
    { -341.57f, -2636.86f, 96.04f, 1.2f },
    { -315.237f, -2600.67f, 96.17f, 1.2f },
    { -450.06f, -2499.79f, 92.04f, 1.2f },
    { -472.266f, -2518.15f, 91.83f, 1.2f },
    { -529.51f, -2538.05f, 92.89f, 1.2f },
    { -402.03f, -2646.4f, 96.22f, 1.2f },
};

Position const westfallLegionAddPos[43] =
{
    { -10698.8f, 1066.89f, 35.45f, 3.14f },
    { -10686.6f, 1014.68f, 34.85f, 3.14f },
    { -10658.4f, 1029.97f, 32.58f, 3.14f },
    { -10642.f, 1000.91f, 32.89f, 3.14f },
    { -10634.4f, 967.32f, 34.15f, 3.14f },
    { -10603.6f, 1003.71f, 34.55f, 3.14f },
    { -10574.3f, 987.56f, 39.10f, 3.14f },
    { -10564.2f, 945.92f, 44.72f, 3.14f },
    { -10538.f, 940.97f, 43.28f, 3.14f },
    { -10501.7f, 951.93f, 39.633f, 3.14f },
    { -10486.2f, 905.28f, 31.92f, 3.14f },
    { -10439.7f, 941.18f, 34.55f, 3.14f },
    { -10435.f, 1001.99f, 39.21f, 3.14f },
    { -10393.3f, 979.323f, 32.09f, 3.14f },
    { -10405.1f, 1027.14f, 33.47f, 3.14f },
    { -10436.8f, 1041.83f, 46.21f, 3.14f },
    { -10438.7f, 1089.22f, 36.67f, 3.14f },
    { -10471.7f, 1084.74f, 45.35f, 3.14f },
    { -10497.3f, 1124.44f, 39.56f, 3.14f },
    { -10527.7f, 1130.94f, 38.96f, 3.14f },
    { -10543.f, 1090.05f, 46.08f, 3.14f },
    { -10563.9f, 1137.57f, 36.51f, 3.14f },
    { -10559.7f, 1181.47f, 32.76f, 3.14f },
    { -10578.2f, 1198.77f, 32.79f, 3.14f },
    { -10607.7f, 1205.64f, 32.47f, 3.14f },
    { -10624.3f, 1172.07f, 34.32f, 3.14f },
    { -10606.5f, 1120.91f, 36.58f, 3.14f },
    { -10562.2f, 1089.57f, 41.49f, 3.14f },
    { -10514.9f, 1061.2f, 55.88f, 3.14f },
    { -10573.5f, 1019.73f, 36.69f, 3.14f },
    { -10707.5f, 1033.23f, 34.52f, 3.14f },
    { -10585.69f, 1056.76f, 36.34f, 2.f},
    { -10626.2f, 1073.6f, 34.39f, 2.f},
    { -10596.5f, 1079.08f, 36.46f, 2.f},
    { -10625.3f, 1153.79f, 34.34f, 2.f},
    { -10681.3f, 1159.62f, 34.25f, 2.f},
    { -10701.6f, 1119.53f, 35.78f, 2.f},
    { -10560.6f, 973.11f, 40.96f, 2.f},
    { -10585.f, 918.02f, 40.76f, 2.f},
    { -10464.5f, 1022.89f, 54.43f, 2.f},
    { -10433.3f, 984.91f, 34.56f, 2.f},
    { -10433.f, 1096.1f, 34.683f, 2.f},
    { -10473.f, 1106.83f, 37.868f, 2.f},
};

Position const commandersPosWB[31] =
{
    { -10520.85f, 1068.28f, 54.65f, 2.02f },
    { -453.63f, -2647.96f, 95.47f, 3.11f },
};

Position const DalaranPos = { -835.720f, 4553.99f, 728.50f, 4.61f };

Position const stromgardPlayersPos[13] =
{
    { -1504.31f, -1804.85f, 67.46f, 2.f },
    { -1504.2f, -1762.84f, 68.69f, 2.f },
    { -1511.22f, -1700.69f, 68.28f, 2.f },
    { -1541.18f, -1681.48f, 73.66f, 2.f },
    { -1647.79f, -1658.76f, 69.05f, 2.f },
    { -1693.9f, -1606.67f, 59.50f, 2.f },
    { -1697.99f, -1707.76f, 54.85f, 2.f },
    { -1610.94f, -1759.06f, 89.36f, 2.f },
    { -1611.57f, -1818.15f, 89.06f, 2.f },
    { -1659.77f, -1902.86f, 90.58f, 2.f },
    { -1712.81f, -1852.82f, 81.24f, 2.f },
    { -1586.45f, -1885.61f, 68.51f, 2.f },
    { -1528.94f, -1804.49f, 71.54f, 2.f },
};

Position const aliShipAirPos_A[6] =
{
    { 6222.21f, 977.36f, 680.5f, 3.54f },
    { 6186.52f, 974.613f, 677.33f, 3.3f },
    { 6195.98f, 956.025f, 677.33f, 3.3f },
    { 6159.36f, 945.487f, 677.314f, 3.2f },
    { 6155.4f, 970.52f, 677.31f, 2.5f },
    { 6126.8f, 941.97f, 696.93f, 1.5f },
};

Position const hordeofficerPos = { 6201.98f, 969.83f, 677.36f, 3.44f };
Position const aliofficerPos = { -5145.43f, 2239.14f, 399.80f, 0.07f };

Position const alliShipStart_APos = { 6127.75f, 944.41f, 735.98f, 0.30f };
Position const alliShipStart_HPos = { -5066.48f, 2246.28f, 455.19f, 3.22f };

Position const aliShipAirPos_H[6] =
{
    { -5163.06f, 2237.79f, 447.54f, 3.54f },
    { -5129.46f, 2239.44f, 447.54f, 1.54f },
    { -5093.48f, 2250.87f, 447.54f, 2.54f },
    { -5091.4f, 2229.99f, 447.54f, 1.54f },
    { -5052.06f, 2247.45f, 447.54f, 2.54f },
    { -5068.24f, 2246.05f, 447.542f, 3.54f },
};

Position const aliShipInsidePos_A[11] =
{
    { 6137.12f, 948.08f, 680.24f, 3.54f },
    { 6148.75f, 943.20f, 666.41f, 3.54f },
    { 6152.96f, 969.146f, 666.39f, 3.54f },
    { 6122.42f, 945.60f, 666.08f, 3.54f },
    { 6182.84f, 986.30f, 666.44f, 3.54f },
    { 6195.8f, 942.62f, 651.85f, 3.54f },
    { 6222.15f, 967.94f, 651.63f, 3.54f },
    { 6181.83f, 989.859f, 651.57f, 3.54f },
    { 6143.35f, 970.669f, 651.662f, 3.54f },
    { 6158.78f, 933.50f, 651.68f, 3.54f },
    { 6137.92f, 947.911f, 651.52f, 3.54f },
};

Position const aliShipInsidePos_H[22] =
{
    { -5115.37f, 2255.81f, 399.67f, 2.3f },
    { -5130.16f, 2252.7f, 399.74f, 1.3f },
    { -5127.81f, 2229.75f, 399.7f, 1.3f },
    { -5156.f, 2235.26f, 402.6f, 1.3f },
    { -5145.71f, 2238.72f, 399.80f, 1.3f },
    { -5091.08f, 2230.22f, 399.73f, 1.3f },
    { -5093.56f, 2256.69f, 399.73f, 1.3f },
    { -5068.69f, 2285.33f, 2285.33f, 1.3f },
    { -5057.29f, 2251.32f, 419.37f, 1.3f },
    { -5063.01f, 2212.04f, 404.30f, 1.3f },
    { -5071.74f, 2245.5f, 402.68f, 1.3f },
    { -5061.82f, 2246.14f, 404.47f, 3.54f },
    { -5088.42f, 2229.79f, 388.839f, 1.54f },
    { -5084.3f, 2258.23f, 388.86f, 2.54f },
    { -5148.93f, 2256.2f, 388.88f, 3.54f },
    { -5127.89f, 2219.8f, 388.88f, 1.54f },
    { -5154.4f, 2230.2f, 374.07f, 1.54f },
    { -5131.46f, 2262.2f, 374.00f, 3.54f },
    { -5094.64f, 2262.94f, 374.11f, 2.54f },
    { -5087.21f, 2232.06f, 374.052f, 1.54f },
    { -5106.28f, 2219.48f, 374.02f, 3.54f },
    { -5150.85f, 2224.82f, 374.08f, 2.54f },
};

Position const hordeWSGResPos = { 1056.75f, 1372.84f, 328.48f, 0.15f };
Position const aliWSGResPos = { 1406.66f, 1561.62f, 328.36f, 3.23f };

Position const WSG_bonusPos[10] =
{
    { 1354.9f, 1488.86f, 324.31f, 1.f },
    { 1305.46f, 1412.29f, 316.004f, 1.f },
    { 1263.3f, 1473.78f, 311.53f, 1.f },
    { 1247.04f, 1506.77f, 308.09f, 1.f },
    { 1202.71f, 1518.69f, 307.77f, 1.f },
    { 1163.78f, 1458.5f, 310.38f, 1.f },
    { 1202.06f, 1391.39f, 310.106f, 1.f },
    { 1228.09f, 1399.84f, 310.51f, 1.f },
    { 1216.88f, 1346.21f, 312.97f, 1.f },
    { 1224.17f, 1453.22f, 321.435f, 1.f },
};

Position const AtrayFlyPhasePos[8] =
{
    { 3563.32f, -146.515f, 100.727f }, //z 105.f changed
    { 3609.74f, -127.148f, 100.727f },
    { 3633.14f, -134.637f, 100.727f },
    { 3617.07f, -197.425f, 100.727f },
    { 3648.28f, -186.181f, 100.727f },
    { 3657.5f, -158.714f, 100.727f },
    { 3597.58f, -114.193f, 100.727f },
    { 3587.52f, -182.84f, 100.727f },
};

Position const AtrayFlyEndPos = { 3606.88f, -158.52f, 62.67f };

Position const AtrayHomePos = { 3606.88f, -158.52f, 60.67f, 0.88f };

Position const valkyrGuardPos[7] =
{
    { 6506.79f, -4060.8f, 658.347f, 3.678f },
    { 6460.52f, -3987.69f, 658.284f, 5.745f },
    { 6522.49f, -3977.67f, 658.29f, 3.19f },
    { 6454.11f, -4068.18f, 658.431f, 0.850f },
    { 6487.27f, -3928.76f, 658.41f, 5.265f },
    { 6558.15f, -4032.09f, 658.44f, 2.371f },
    { 6560.31f, -3937.49f, 658.30f, 4.26f },
};

Position const evalaPortalsPos[9] =
{
    { 6473.99f, -4010.85f, 658.34f, 5.23f },
    { 6489.66f, -4001.10f, 658.28f, 4.86f },
    { 6509.03f, -3999.50f, 658.46f, 4.02f },
    { 6518.94f, -4012.84f, 658.93f, 3.50f },
    { 6527.08f, -4026.52f, 658.94f, 3.30f },
    { 6522.94f, -4039.75f, 658.45f, 2.80f },
    { 6511.86f, -4054.25f, 658.28f, 2.52f },
    { 6496.16f, -4056.46f, 658.46f, 1.67f },
    { 6475.57f, -4055.20f, 658.56f, 1.39f },
};

const Position voidZonePositions[24] =
{
    { 6476.93f, -4021.21f, 658.53f, 6.27f },
    { 6492.14f, -4023.46f, 658.63f, 4.86f },
    { 6477.37f, -4009.6f, 658.35f, 0.96f },
    { 6492.02f, -4012.02f, 658.43f, 4.24f },
    { 6463.57f, -4028.77f, 658.36f, 5.84f },
    { 6465.35f, -4017.56f, 658.32f, 5.14f },
    { 6503.43f, -4020.73f, 658.55f, 5.632f },
    { 6507.46f, -4029.79f, 658.55f, 3.052f },
    { 6499.42f, -4030.91f, 658.61f, 3.53f },
    { 6498.42f, -4044.43f, 658.54f, 2.63f },
    { 6512.f, -4041.66f, 658.35f, 0.21f },
    { 6519.19f, -4031.14f, 658.62f, 1.07f },
    { 6516.45f, -4019.99f, 658.79f, 2.03f },
    { 6508.11f, -4002.62f, 658.48f, 3.68f },
    { 6512.24f, -4054.7f, 658.28f, 2.94f },
    { 6502.2f, -4062.31f, 658.39f, 2.45f },
    { 6493.04f, -4053.45f, 658.52f, 2.40f },
    { 6483.42f, -4043.67f, 658.68f, 2.22f },
    { 6478.09f, -4060.33f, 658.57f, 0.46f },
    { 6489.99f, -4069.59f, 658.602f, 5.42f },
    { 6468.34f, -4052.27f, 658.57f, 0.63f },
    { 6458.67f, -4043.61f, 658.37f, 0.66f },
    { 6450.44f, -4030.49f, 658.28f, 0.31f },
    { 6458.45f, -4054.61f, 658.44f, 5.67f },
};

const Position bossPositions[2] = 
{
    { 3606.89f, -158.528f, 59.67f, 0.884f},
    { 6478.38f, -4035.08f, 658.671f, 0.266f},
};

enum Locs
{
    karazhan            = 51000,
    vaultofthewardens   = 51001,
    eyeofazhara         = 51002,
    suramarcatacombs    = 51004,
    courtofstars        = 51005,
    mawofsouls          = 51006,
    trialofvalor        = 51007,
    neltarionlair       = 51008,
    blackrookhold       = 51009,
    darkheartthicket    = 51010,
    emeraldnightmare    = 51022,
    tombofsargeras      = 51011,
    triumvirate         = 51012,
    antorus             = 51013,
    twomoons            = 51014,
    sevenstars          = 51015,
    isleofthunder       = 51016,
    isleofqueldanas     = 51017,
    shattrath           = 51018,
    ashranA             = 51019,
    ashranH             = 51020,
    dalaranN            = 51021,

    nextpage            = 51023,
    temp                = 51024,
    prevpage            = 51025,
};



#endif