/*
* Copyright (C) 2008-2018 TrinityCore <https://www.trinitycore.org/>
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or (at your
* option) any later version.
*
* This program is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
* more details.
*
* You should have received a copy of the GNU General Public License along
* with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#include "UpdateFieldFlags.h"

uint32 ItemUpdateFieldFlags[CONTAINER_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_OWNER
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_OWNER+1
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_OWNER+2
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_OWNER+3
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CONTAINED
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CONTAINED+1
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CONTAINED+2
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CONTAINED+3
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CREATOR
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CREATOR+1
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CREATOR+2
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CREATOR+3
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_GIFT_CREATOR
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_GIFT_CREATOR+1
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_GIFT_CREATOR+2
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_GIFT_CREATOR+3
    UF_FLAG_OWNER,                                          // ITEM_FIELD_STACK_COUNT
    UF_FLAG_OWNER,                                          // ITEM_FIELD_EXPIRATION
    UF_FLAG_OWNER,                                          // ITEM_FIELD_SPELL_CHARGES
    UF_FLAG_OWNER,                                          // ITEM_FIELD_SPELL_CHARGES+1
    UF_FLAG_OWNER,                                          // ITEM_FIELD_SPELL_CHARGES+2
    UF_FLAG_OWNER,                                          // ITEM_FIELD_SPELL_CHARGES+3
    UF_FLAG_OWNER,                                          // ITEM_FIELD_SPELL_CHARGES+4
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+1
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+2
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+3
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+4
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+5
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+6
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+7
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+8
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+9
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+10
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+11
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+12
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+13
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+14
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+15
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+16
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+17
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+18
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+19
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+20
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+21
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+22
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+23
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+24
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+25
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+26
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+27
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+28
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+29
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+30
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+31
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+32
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+33
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+34
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+35
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+36
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+37
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_ENCHANTMENT+38
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_PROPERTY_SEED
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_RANDOM_PROPERTIES_ID
    UF_FLAG_OWNER,                                          // ITEM_FIELD_DURABILITY
    UF_FLAG_OWNER,                                          // ITEM_FIELD_MAX_DURABILITY
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CREATE_PLAYED_TIME
    UF_FLAG_OWNER,                                          // ITEM_FIELD_MODIFIERS_MASK
    UF_FLAG_PUBLIC,                                         // ITEM_FIELD_CONTEXT
    UF_FLAG_OWNER,                                          // ITEM_FIELD_ARTIFACT_XP
    UF_FLAG_OWNER,                                          // ITEM_FIELD_ARTIFACT_XP+1
    UF_FLAG_OWNER,                                          // ITEM_FIELD_ITEM_APPEARANCE_MOD_ID
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+1
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+2
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+3
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+4
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+5
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+6
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+7
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+8
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+9
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+10
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+11
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+12
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+13
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+14
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+15
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+16
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+17
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+18
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+19
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+20
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+21
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+22
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+23
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+24
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+25
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+26
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+27
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+28
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+29
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+30
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+31
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+32
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+33
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+34
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+35
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+36
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+37
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+38
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+39
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+40
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+41
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+42
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+43
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+44
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+45
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+46
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+47
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+48
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+49
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+50
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+51
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+52
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+53
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+54
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+55
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+56
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+57
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+58
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+59
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+60
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+61
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+62
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+63
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+64
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+65
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+66
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+67
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+68
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+69
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+70
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+71
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+72
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+73
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+74
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+75
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+76
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+77
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+78
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+79
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+80
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+81
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+82
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+83
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+84
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+85
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+86
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+87
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+88
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+89
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+90
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+91
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+92
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+93
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+94
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+95
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+96
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+97
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+98
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+99
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+100
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+101
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+102
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+103
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+104
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+105
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+106
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+107
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+108
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+109
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+110
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+111
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+112
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+113
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+114
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+115
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+116
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+117
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+118
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+119
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+120
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+121
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+122
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+123
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+124
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+125
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+126
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+127
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+128
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+129
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+130
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+131
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+132
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+133
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+134
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+135
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+136
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+137
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+138
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+139
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+140
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+141
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+142
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_SLOT_1+143
    UF_FLAG_PUBLIC,                                         // CONTAINER_FIELD_NUM_SLOTS
};

uint32 ItemDynamicFieldFlags[CONTAINER_DYNAMIC_END] =
{
    UF_FLAG_OWNER,                                          // ITEM_DYNAMIC_FIELD_MODIFIERS
    UF_FLAG_OWNER | UF_FLAG_UNK0X100,                       // ITEM_DYNAMIC_FIELD_BONUSLIST_IDS
    UF_FLAG_OWNER,                                          // ITEM_DYNAMIC_FIELD_ARTIFACT_POWERS
    UF_FLAG_OWNER,                                          // ITEM_DYNAMIC_FIELD_GEMS
    UF_FLAG_OWNER,                                          // ITEM_DYNAMIC_FIELD_RELIC_TALENT_DATA
};

uint32 UnitUpdateFieldFlags[PLAYER_FIELD_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARM
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARM+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARM+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARM+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMON
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMON+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMON+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMON+3
    UF_FLAG_PRIVATE,                                        // UNIT_FIELD_CRITTER
    UF_FLAG_PRIVATE,                                        // UNIT_FIELD_CRITTER+1
    UF_FLAG_PRIVATE,                                        // UNIT_FIELD_CRITTER+2
    UF_FLAG_PRIVATE,                                        // UNIT_FIELD_CRITTER+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARMED_BY
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARMED_BY+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARMED_BY+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CHARMED_BY+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMONED_BY
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMONED_BY+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMONED_BY+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMONED_BY+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CREATED_BY
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CREATED_BY+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CREATED_BY+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CREATED_BY+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_DEMON_CREATOR
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_DEMON_CREATOR+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_DEMON_CREATOR+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_DEMON_CREATOR+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_TARGET
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_TARGET+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_TARGET+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_TARGET+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLE_PET_COMPANION_GUID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLE_PET_COMPANION_GUID+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLE_PET_COMPANION_GUID+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLE_PET_COMPANION_GUID+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLE_PET_DB_ID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLE_PET_DB_ID+1
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_CHANNEL_DATA
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_CHANNEL_DATA+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SUMMONED_BY_HOME_REALM
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BYTES_0
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_DISPLAY_POWER
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_OVERRIDE_DISPLAY_POWER_ID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_HEALTH
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_HEALTH+1
    UF_FLAG_PUBLIC | UF_FLAG_URGENT_SELF_ONLY,              // UNIT_FIELD_POWER
    UF_FLAG_PUBLIC | UF_FLAG_URGENT_SELF_ONLY,              // UNIT_FIELD_POWER+1
    UF_FLAG_PUBLIC | UF_FLAG_URGENT_SELF_ONLY,              // UNIT_FIELD_POWER+2
    UF_FLAG_PUBLIC | UF_FLAG_URGENT_SELF_ONLY,              // UNIT_FIELD_POWER+3
    UF_FLAG_PUBLIC | UF_FLAG_URGENT_SELF_ONLY,              // UNIT_FIELD_POWER+4
    UF_FLAG_PUBLIC | UF_FLAG_URGENT_SELF_ONLY,              // UNIT_FIELD_POWER+5
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_HEALTH
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_HEALTH+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_POWER
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_POWER+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_POWER+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_POWER+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_POWER+4
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_POWER+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_FLAT_MODIFIER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_FLAT_MODIFIER+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_FLAT_MODIFIER+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_FLAT_MODIFIER+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_FLAT_MODIFIER+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_FLAT_MODIFIER+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_INTERRUPTED_FLAT_MODIFIER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_INTERRUPTED_FLAT_MODIFIER+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_INTERRUPTED_FLAT_MODIFIER+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_INTERRUPTED_FLAT_MODIFIER+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_INTERRUPTED_FLAT_MODIFIER+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_UNIT_ALL,     // UNIT_FIELD_POWER_REGEN_INTERRUPTED_FLAT_MODIFIER+5
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LEVEL
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_EFFECTIVE_LEVEL
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SANDBOX_SCALING_ID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SCALING_LEVEL_MIN
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SCALING_LEVEL_MAX
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SCALING_LEVEL_DELTA
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_FACTION_TEMPLATE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_VIRTUAL_ITEMS
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_VIRTUAL_ITEMS+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_VIRTUAL_ITEMS+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_VIRTUAL_ITEMS+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_VIRTUAL_ITEMS+4
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_VIRTUAL_ITEMS+5
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_FLAGS
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_FLAGS_2
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_FLAGS_3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_AURA_STATE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_ATTACK_ROUND_BASE_TIME
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_ATTACK_ROUND_BASE_TIME+1
    UF_FLAG_PRIVATE,                                        // UNIT_FIELD_RANGED_ATTACK_ROUND_BASE_TIME
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BOUNDING_RADIUS
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_COMBAT_REACH
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_DISPLAY_ID
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_NATIVE_DISPLAY_ID
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_FIELD_MOUNT_DISPLAY_ID
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_MIN_DAMAGE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_MAX_DAMAGE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_MIN_OFF_HAND_DAMAGE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_MAX_OFF_HAND_DAMAGE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BYTES_1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_PET_NUMBER
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_PET_NAME_TIMESTAMP
    UF_FLAG_OWNER,                                          // UNIT_FIELD_PET_EXPERIENCE
    UF_FLAG_OWNER,                                          // UNIT_FIELD_PET_NEXT_LEVEL_EXPERIENCE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MOD_CASTING_SPEED
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MOD_SPELL_HASTE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MOD_HASTE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MOD_RANGED_HASTE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MOD_HASTE_REGEN
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MOD_TIME_RATE
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_CREATED_BY_SPELL
    UF_FLAG_PUBLIC | UF_FLAG_DYNAMIC,                       // UNIT_FIELD_NPC_FLAGS
    UF_FLAG_PUBLIC | UF_FLAG_DYNAMIC,                       // UNIT_FIELD_NPC_FLAGS+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_EMOTE_STATE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_POS_BUFF
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_POS_BUFF+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_POS_BUFF+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_POS_BUFF+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_NEG_BUFF
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_NEG_BUFF+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_NEG_BUFF+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_STAT_NEG_BUFF+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER | UF_FLAG_SPECIAL_INFO, // UNIT_FIELD_RESISTANCES+6
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_POSITIVE+6
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RESISTANCE_BUFF_MODS_NEGATIVE+6
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_MOD_BONUS_ARMOR
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BASE_MANA
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_BASE_HEALTH
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BYTES_2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_ATTACK_POWER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_ATTACK_POWER_MOD_POS
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_ATTACK_POWER_MOD_NEG
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_ATTACK_POWER_MULTIPLIER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RANGED_ATTACK_POWER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RANGED_ATTACK_POWER_MOD_POS
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RANGED_ATTACK_POWER_MOD_NEG
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_RANGED_ATTACK_POWER_MULTIPLIER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_ATTACK_SPEED_AURA
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_MIN_RANGED_DAMAGE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_MAX_RANGED_DAMAGE
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MODIFIER+6
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER+1
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER+2
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER+3
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER+4
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER+5
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_POWER_COST_MULTIPLIER+6
    UF_FLAG_PRIVATE | UF_FLAG_OWNER,                        // UNIT_FIELD_MAX_HEALTH_MODIFIER
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_HOVER_HEIGHT
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MIN_ITEM_LEVEL_CUTOFF
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MIN_ITEM_LEVEL
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_MAX_ITEM_LEVEL
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_WILD_BATTLEPET_LEVEL
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_BATTLEPET_COMPANION_NAME_TIMESTAMP
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_INTERACT_SPELLID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_SPELL_VISUAL_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_ANIM_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_ANIM_KIT_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_WORLD_EFFECT_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_WORLD_EFFECT_ID+1
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_WORLD_EFFECT_ID+2
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // UNIT_FIELD_STATE_WORLD_EFFECT_ID+3
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_SCALE_DURATION
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOKS_LIKE_MOUNT_ID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOKS_LIKE_CREATURE_ID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOK_AT_CONTROLLER_ID
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOK_AT_CONTROLLER_TARGET
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOK_AT_CONTROLLER_TARGET+1
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOK_AT_CONTROLLER_TARGET+2
    UF_FLAG_PUBLIC,                                         // UNIT_FIELD_LOOK_AT_CONTROLLER_TARGET+3
    UF_FLAG_PUBLIC,                                         // PLAYER_DUEL_ARBITER
    UF_FLAG_PUBLIC,                                         // PLAYER_DUEL_ARBITER+1
    UF_FLAG_PUBLIC,                                         // PLAYER_DUEL_ARBITER+2
    UF_FLAG_PUBLIC,                                         // PLAYER_DUEL_ARBITER+3
    UF_FLAG_PUBLIC,                                         // PLAYER_WOW_ACCOUNT
    UF_FLAG_PUBLIC,                                         // PLAYER_WOW_ACCOUNT+1
    UF_FLAG_PUBLIC,                                         // PLAYER_WOW_ACCOUNT+2
    UF_FLAG_PUBLIC,                                         // PLAYER_WOW_ACCOUNT+3
    UF_FLAG_PUBLIC,                                         // PLAYER_LOOT_TARGET_GUID
    UF_FLAG_PUBLIC,                                         // PLAYER_LOOT_TARGET_GUID+1
    UF_FLAG_PUBLIC,                                         // PLAYER_LOOT_TARGET_GUID+2
    UF_FLAG_PUBLIC,                                         // PLAYER_LOOT_TARGET_GUID+3
    UF_FLAG_PUBLIC,                                         // PLAYER_FLAGS
    UF_FLAG_PUBLIC,                                         // PLAYER_FLAGS_EX
    UF_FLAG_PUBLIC,                                         // PLAYER_GUILDRANK
    UF_FLAG_PUBLIC,                                         // PLAYER_GUILDDELETE_DATE
    UF_FLAG_PUBLIC,                                         // PLAYER_GUILDLEVEL
    UF_FLAG_PUBLIC,                                         // PLAYER_BYTES
    UF_FLAG_PUBLIC,                                         // PLAYER_BYTES_2
    UF_FLAG_PUBLIC,                                         // PLAYER_BYTES_3
    UF_FLAG_PUBLIC,                                         // PLAYER_BYTES_4
    UF_FLAG_PUBLIC,                                         // PLAYER_DUEL_TEAM
    UF_FLAG_PUBLIC,                                         // PLAYER_GUILD_TIMESTAMP
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+1
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+2
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+3
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+4
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+5
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+6
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+7
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+8
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+9
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+10
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+11
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+12
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+13
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+14
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+15
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+16
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+17
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+18
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+19
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+20
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+21
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+22
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+23
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+24
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+25
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+26
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+27
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+28
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+29
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+30
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+31
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+32
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+33
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+34
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+35
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+36
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+37
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+38
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+39
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+40
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+41
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+42
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+43
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+44
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+45
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+46
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+47
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+48
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+49
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+50
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+51
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+52
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+53
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+54
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+55
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+56
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+57
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+58
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+59
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+60
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+61
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+62
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+63
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+64
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+65
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+66
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+67
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+68
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+69
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+70
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+71
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+72
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+73
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+74
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+75
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+76
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+77
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+78
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+79
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+80
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+81
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+82
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+83
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+84
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+85
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+86
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+87
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+88
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+89
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+90
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+91
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+92
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+93
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+94
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+95
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+96
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+97
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+98
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+99
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+100
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+101
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+102
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+103
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+104
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+105
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+106
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+107
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+108
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+109
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+110
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+111
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+112
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+113
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+114
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+115
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+116
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+117
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+118
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+119
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+120
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+121
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+122
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+123
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+124
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+125
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+126
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+127
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+128
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+129
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+130
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+131
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+132
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+133
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+134
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+135
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+136
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+137
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+138
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+139
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+140
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+141
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+142
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+143
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+144
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+145
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+146
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+147
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+148
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+149
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+150
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+151
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+152
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+153
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+154
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+155
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+156
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+157
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+158
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+159
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+160
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+161
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+162
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+163
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+164
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+165
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+166
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+167
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+168
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+169
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+170
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+171
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+172
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+173
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+174
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+175
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+176
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+177
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+178
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+179
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+180
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+181
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+182
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+183
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+184
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+185
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+186
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+187
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+188
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+189
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+190
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+191
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+192
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+193
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+194
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+195
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+196
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+197
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+198
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+199
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+200
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+201
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+202
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+203
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+204
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+205
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+206
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+207
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+208
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+209
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+210
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+211
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+212
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+213
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+214
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+215
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+216
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+217
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+218
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+219
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+220
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+221
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+222
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+223
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+224
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+225
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+226
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+227
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+228
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+229
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+230
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+231
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+232
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+233
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+234
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+235
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+236
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+237
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+238
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+239
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+240
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+241
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+242
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+243
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+244
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+245
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+246
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+247
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+248
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+249
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+250
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+251
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+252
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+253
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+254
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+255
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+256
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+257
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+258
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+259
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+260
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+261
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+262
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+263
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+264
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+265
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+266
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+267
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+268
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+269
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+270
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+271
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+272
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+273
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+274
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+275
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+276
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+277
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+278
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+279
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+280
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+281
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+282
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+283
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+284
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+285
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+286
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+287
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+288
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+289
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+290
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+291
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+292
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+293
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+294
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+295
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+296
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+297
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+298
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+299
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+300
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+301
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+302
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+303
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+304
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+305
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+306
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+307
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+308
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+309
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+310
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+311
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+312
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+313
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+314
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+315
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+316
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+317
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+318
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+319
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+320
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+321
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+322
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+323
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+324
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+325
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+326
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+327
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+328
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+329
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+330
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+331
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+332
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+333
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+334
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+335
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+336
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+337
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+338
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+339
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+340
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+341
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+342
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+343
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+344
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+345
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+346
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+347
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+348
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+349
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+350
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+351
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+352
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+353
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+354
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+355
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+356
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+357
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+358
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+359
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+360
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+361
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+362
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+363
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+364
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+365
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+366
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+367
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+368
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+369
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+370
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+371
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+372
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+373
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+374
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+375
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+376
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+377
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+378
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+379
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+380
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+381
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+382
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+383
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+384
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+385
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+386
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+387
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+388
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+389
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+390
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+391
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+392
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+393
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+394
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+395
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+396
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+397
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+398
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+399
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+400
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+401
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+402
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+403
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+404
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+405
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+406
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+407
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+408
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+409
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+410
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+411
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+412
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+413
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+414
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+415
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+416
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+417
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+418
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+419
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+420
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+421
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+422
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+423
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+424
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+425
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+426
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+427
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+428
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+429
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+430
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+431
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+432
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+433
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+434
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+435
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+436
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+437
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+438
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+439
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+440
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+441
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+442
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+443
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+444
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+445
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+446
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+447
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+448
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+449
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+450
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+451
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+452
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+453
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+454
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+455
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+456
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+457
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+458
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+459
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+460
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+461
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+462
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+463
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+464
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+465
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+466
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+467
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+468
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+469
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+470
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+471
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+472
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+473
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+474
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+475
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+476
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+477
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+478
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+479
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+480
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+481
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+482
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+483
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+484
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+485
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+486
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+487
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+488
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+489
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+490
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+491
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+492
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+493
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+494
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+495
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+496
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+497
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+498
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+499
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+500
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+501
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+502
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+503
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+504
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+505
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+506
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+507
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+508
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+509
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+510
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+511
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+512
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+513
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+514
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+515
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+516
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+517
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+518
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+519
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+520
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+521
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+522
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+523
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+524
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+525
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+526
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+527
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+528
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+529
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+530
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+531
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+532
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+533
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+534
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+535
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+536
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+537
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+538
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+539
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+540
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+541
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+542
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+543
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+544
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+545
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+546
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+547
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+548
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+549
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+550
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+551
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+552
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+553
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+554
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+555
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+556
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+557
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+558
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+559
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+560
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+561
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+562
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+563
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+564
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+565
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+566
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+567
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+568
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+569
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+570
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+571
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+572
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+573
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+574
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+575
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+576
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+577
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+578
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+579
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+580
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+581
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+582
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+583
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+584
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+585
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+586
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+587
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+588
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+589
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+590
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+591
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+592
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+593
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+594
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+595
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+596
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+597
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+598
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+599
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+600
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+601
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+602
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+603
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+604
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+605
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+606
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+607
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+608
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+609
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+610
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+611
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+612
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+613
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+614
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+615
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+616
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+617
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+618
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+619
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+620
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+621
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+622
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+623
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+624
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+625
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+626
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+627
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+628
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+629
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+630
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+631
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+632
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+633
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+634
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+635
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+636
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+637
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+638
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+639
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+640
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+641
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+642
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+643
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+644
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+645
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+646
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+647
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+648
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+649
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+650
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+651
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+652
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+653
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+654
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+655
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+656
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+657
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+658
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+659
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+660
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+661
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+662
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+663
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+664
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+665
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+666
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+667
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+668
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+669
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+670
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+671
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+672
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+673
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+674
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+675
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+676
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+677
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+678
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+679
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+680
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+681
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+682
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+683
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+684
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+685
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+686
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+687
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+688
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+689
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+690
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+691
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+692
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+693
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+694
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+695
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+696
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+697
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+698
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+699
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+700
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+701
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+702
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+703
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+704
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+705
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+706
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+707
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+708
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+709
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+710
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+711
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+712
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+713
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+714
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+715
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+716
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+717
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+718
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+719
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+720
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+721
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+722
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+723
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+724
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+725
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+726
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+727
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+728
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+729
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+730
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+731
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+732
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+733
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+734
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+735
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+736
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+737
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+738
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+739
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+740
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+741
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+742
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+743
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+744
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+745
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+746
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+747
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+748
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+749
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+750
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+751
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+752
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+753
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+754
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+755
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+756
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+757
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+758
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+759
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+760
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+761
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+762
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+763
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+764
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+765
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+766
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+767
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+768
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+769
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+770
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+771
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+772
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+773
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+774
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+775
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+776
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+777
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+778
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+779
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+780
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+781
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+782
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+783
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+784
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+785
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+786
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+787
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+788
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+789
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+790
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+791
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+792
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+793
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+794
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+795
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+796
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+797
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+798
    UF_FLAG_PARTY_MEMBER,                                   // PLAYER_QUEST_LOG+799
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+1
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+2
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+3
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+4
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+5
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+6
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+7
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+8
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+9
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+10
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+11
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+12
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+13
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+14
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+15
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+16
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+17
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+18
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+19
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+20
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+21
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+22
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+23
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+24
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+25
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+26
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+27
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+28
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+29
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+30
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+31
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+32
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+33
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+34
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+35
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+36
    UF_FLAG_PUBLIC,                                         // PLAYER_VISIBLE_ITEM+37
    UF_FLAG_PUBLIC,                                         // PLAYER_CHOSEN_TITLE
    UF_FLAG_PUBLIC,                                         // PLAYER_FAKE_INEBRIATION
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_VIRTUAL_PLAYER_REALM
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_CURRENT_SPEC_ID
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_TAXI_MOUNT_ANIM_KIT_ID
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_AVG_ITEM_LEVEL
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_AVG_ITEM_LEVEL+1
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_AVG_ITEM_LEVEL+2
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_AVG_ITEM_LEVEL+3
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_CURRENT_BATTLE_PET_BREED_QUALITY
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_PRESTIGE
    UF_FLAG_PUBLIC,                                         // PLAYER_FIELD_HONOR_LEVEL
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+9
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+10
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+12
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+13
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+14
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+15
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+16
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+17
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+18
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+19
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+20
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+21
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+22
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+23
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+24
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+25
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+26
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+27
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+28
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+29
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+30
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+31
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+32
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+33
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+34
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+35
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+36
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+37
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+38
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+39
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+40
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+41
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+42
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+43
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+44
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+45
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+46
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+47
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+48
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+49
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+50
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+51
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+52
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+53
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+54
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+55
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+56
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+57
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+58
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+59
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+60
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+61
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+62
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+63
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+64
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+65
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+66
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+67
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+68
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+69
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+70
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+71
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+72
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+73
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+74
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+75
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+76
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+77
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+78
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+79
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+80
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+81
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+82
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+83
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+84
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+85
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+86
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+87
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+88
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+89
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+90
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+91
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+92
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+93
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+94
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+95
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+96
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+97
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+98
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+99
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+100
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+101
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+102
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+103
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+104
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+105
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+106
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+107
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+108
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+109
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+110
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+111
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+112
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+113
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+114
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+115
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+116
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+117
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+118
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+119
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+120
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+121
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+122
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+123
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+124
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+125
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+126
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+127
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+128
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+129
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+130
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+131
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+132
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+133
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+134
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+135
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+136
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+137
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+138
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+139
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+140
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+141
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+142
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+143
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+144
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+145
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+146
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+147
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+148
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+149
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+150
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+151
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+152
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+153
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+154
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+155
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+156
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+157
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+158
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+159
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+160
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+161
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+162
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+163
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+164
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+165
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+166
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+167
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+168
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+169
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+170
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+171
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+172
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+173
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+174
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+175
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+176
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+177
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+178
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+179
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+180
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+181
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+182
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+183
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+184
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+185
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+186
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+187
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+188
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+189
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+190
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+191
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+192
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+193
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+194
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+195
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+196
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+197
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+198
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+199
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+200
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+201
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+202
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+203
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+204
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+205
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+206
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+207
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+208
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+209
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+210
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+211
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+212
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+213
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+214
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+215
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+216
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+217
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+218
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+219
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+220
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+221
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+222
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+223
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+224
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+225
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+226
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+227
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+228
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+229
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+230
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+231
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+232
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+233
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+234
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+235
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+236
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+237
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+238
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+239
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+240
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+241
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+242
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+243
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+244
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+245
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+246
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+247
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+248
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+249
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+250
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+251
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+252
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+253
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+254
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+255
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+256
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+257
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+258
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+259
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+260
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+261
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+262
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+263
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+264
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+265
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+266
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+267
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+268
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+269
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+270
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+271
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+272
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+273
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+274
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+275
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+276
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+277
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+278
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+279
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+280
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+281
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+282
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+283
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+284
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+285
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+286
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+287
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+288
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+289
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+290
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+291
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+292
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+293
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+294
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+295
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+296
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+297
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+298
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+299
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+300
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+301
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+302
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+303
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+304
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+305
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+306
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+307
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+308
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+309
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+310
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+311
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+312
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+313
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+314
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+315
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+316
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+317
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+318
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+319
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+320
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+321
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+322
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+323
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+324
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+325
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+326
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+327
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+328
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+329
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+330
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+331
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+332
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+333
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+334
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+335
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+336
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+337
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+338
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+339
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+340
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+341
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+342
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+343
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+344
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+345
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+346
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+347
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+348
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+349
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+350
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+351
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+352
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+353
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+354
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+355
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+356
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+357
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+358
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+359
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+360
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+361
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+362
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+363
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+364
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+365
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+366
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+367
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+368
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+369
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+370
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+371
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+372
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+373
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+374
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+375
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+376
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+377
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+378
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+379
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+380
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+381
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+382
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+383
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+384
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+385
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+386
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+387
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+388
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+389
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+390
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+391
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+392
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+393
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+394
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+395
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+396
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+397
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+398
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+399
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+400
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+401
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+402
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+403
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+404
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+405
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+406
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+407
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+408
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+409
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+410
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+411
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+412
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+413
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+414
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+415
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+416
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+417
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+418
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+419
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+420
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+421
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+422
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+423
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+424
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+425
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+426
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+427
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+428
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+429
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+430
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+431
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+432
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+433
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+434
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+435
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+436
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+437
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+438
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+439
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+440
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+441
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+442
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+443
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+444
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+445
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+446
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+447
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+448
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+449
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+450
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+451
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+452
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+453
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+454
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+455
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+456
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+457
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+458
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+459
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+460
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+461
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+462
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+463
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+464
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+465
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+466
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+467
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+468
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+469
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+470
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+471
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+472
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+473
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+474
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+475
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+476
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+477
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+478
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+479
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+480
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+481
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+482
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+483
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+484
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+485
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+486
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+487
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+488
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+489
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+490
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+491
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+492
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+493
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+494
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+495
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+496
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+497
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+498
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+499
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+500
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+501
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+502
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+503
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+504
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+505
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+506
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+507
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+508
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+509
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+510
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+511
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+512
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+513
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+514
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+515
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+516
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+517
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+518
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+519
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+520
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+521
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+522
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+523
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+524
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+525
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+526
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+527
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+528
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+529
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+530
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+531
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+532
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+533
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+534
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+535
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+536
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+537
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+538
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+539
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+540
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+541
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+542
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+543
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+544
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+545
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+546
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+547
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+548
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+549
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+550
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+551
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+552
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+553
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+554
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+555
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+556
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+557
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+558
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+559
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+560
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+561
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+562
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+563
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+564
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+565
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+566
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+567
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+568
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+569
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+570
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+571
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+572
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+573
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+574
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+575
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+576
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+577
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+578
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+579
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+580
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+581
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+582
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+583
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+584
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+585
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+586
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+587
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+588
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+589
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+590
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+591
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+592
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+593
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+594
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+595
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+596
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+597
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+598
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+599
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+600
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+601
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+602
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+603
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+604
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+605
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+606
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+607
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+608
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+609
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+610
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+611
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+612
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+613
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+614
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+615
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+616
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+617
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+618
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+619
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+620
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+621
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+622
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+623
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+624
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+625
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+626
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+627
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+628
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+629
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+630
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+631
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+632
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+633
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+634
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+635
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+636
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+637
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+638
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+639
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+640
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+641
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+642
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+643
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+644
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+645
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+646
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+647
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+648
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+649
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+650
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+651
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+652
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+653
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+654
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+655
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+656
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+657
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+658
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+659
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+660
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+661
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+662
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+663
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+664
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+665
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+666
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+667
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+668
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+669
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+670
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+671
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+672
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+673
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+674
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+675
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+676
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+677
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+678
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+679
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+680
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+681
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+682
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+683
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+684
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+685
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+686
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+687
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+688
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+689
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+690
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+691
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+692
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+693
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+694
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+695
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+696
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+697
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+698
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+699
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+700
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+701
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+702
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+703
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+704
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+705
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+706
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+707
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+708
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+709
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+710
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+711
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+712
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+713
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+714
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+715
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+716
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+717
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+718
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+719
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+720
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+721
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+722
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+723
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+724
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+725
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+726
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+727
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+728
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+729
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+730
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+731
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+732
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+733
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+734
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+735
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+736
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+737
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+738
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+739
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+740
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+741
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+742
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+743
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+744
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+745
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+746
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+747
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+748
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+749
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+750
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+751
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+752
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+753
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+754
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+755
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+756
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+757
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+758
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+759
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+760
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+761
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+762
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+763
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+764
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+765
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+766
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+767
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+768
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+769
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+770
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+771
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+772
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+773
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+774
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+775
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+776
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+777
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+778
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INV_SLOT_HEAD+779
    UF_FLAG_PRIVATE,                                        // PLAYER_FARSIGHT
    UF_FLAG_PRIVATE,                                        // PLAYER_FARSIGHT+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FARSIGHT+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FARSIGHT+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_SUMMONED_BATTLE_PET_ID
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_SUMMONED_BATTLE_PET_ID+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_SUMMONED_BATTLE_PET_ID+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_SUMMONED_BATTLE_PET_ID+3
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+1
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+2
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+3
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+4
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+5
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+6
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+7
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+8
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+9
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+10
    UF_FLAG_PRIVATE,                                        // PLAYER__FIELD_KNOWN_TITLES+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COINAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COINAGE+1
    UF_FLAG_PRIVATE,                                        // PLAYER_XP
    UF_FLAG_PRIVATE,                                        // PLAYER_NEXT_LEVEL_XP
    UF_FLAG_PRIVATE,                                        // PLAYER_TRIAL_XP
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+1
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+2
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+3
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+4
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+5
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+6
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+7
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+8
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+9
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+10
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+11
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+12
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+13
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+14
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+15
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+16
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+17
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+18
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+19
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+20
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+21
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+22
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+23
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+24
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+25
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+26
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+27
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+28
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+29
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+30
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+31
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+32
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+33
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+34
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+35
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+36
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+37
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+38
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+39
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+40
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+41
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+42
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+43
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+44
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+45
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+46
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+47
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+48
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+49
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+50
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+51
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+52
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+53
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+54
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+55
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+56
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+57
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+58
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+59
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+60
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+61
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+62
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+63
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+64
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+65
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+66
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+67
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+68
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+69
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+70
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+71
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+72
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+73
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+74
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+75
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+76
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+77
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+78
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+79
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+80
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+81
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+82
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+83
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+84
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+85
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+86
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+87
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+88
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+89
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+90
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+91
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+92
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+93
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+94
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+95
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+96
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+97
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+98
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+99
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+100
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+101
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+102
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+103
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+104
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+105
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+106
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+107
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+108
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+109
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+110
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+111
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+112
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+113
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+114
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+115
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+116
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+117
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+118
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+119
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+120
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+121
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+122
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+123
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+124
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+125
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+126
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+127
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+128
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+129
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+130
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+131
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+132
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+133
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+134
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+135
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+136
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+137
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+138
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+139
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+140
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+141
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+142
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+143
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+144
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+145
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+146
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+147
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+148
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+149
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+150
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+151
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+152
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+153
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+154
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+155
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+156
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+157
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+158
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+159
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+160
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+161
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+162
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+163
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+164
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+165
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+166
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+167
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+168
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+169
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+170
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+171
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+172
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+173
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+174
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+175
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+176
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+177
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+178
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+179
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+180
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+181
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+182
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+183
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+184
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+185
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+186
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+187
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+188
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+189
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+190
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+191
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+192
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+193
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+194
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+195
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+196
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+197
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+198
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+199
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+200
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+201
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+202
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+203
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+204
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+205
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+206
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+207
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+208
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+209
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+210
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+211
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+212
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+213
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+214
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+215
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+216
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+217
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+218
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+219
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+220
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+221
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+222
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+223
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+224
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+225
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+226
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+227
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+228
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+229
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+230
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+231
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+232
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+233
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+234
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+235
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+236
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+237
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+238
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+239
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+240
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+241
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+242
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+243
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+244
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+245
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+246
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+247
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+248
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+249
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+250
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+251
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+252
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+253
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+254
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+255
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+256
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+257
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+258
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+259
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+260
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+261
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+262
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+263
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+264
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+265
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+266
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+267
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+268
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+269
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+270
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+271
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+272
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+273
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+274
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+275
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+276
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+277
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+278
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+279
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+280
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+281
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+282
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+283
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+284
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+285
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+286
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+287
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+288
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+289
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+290
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+291
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+292
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+293
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+294
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+295
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+296
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+297
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+298
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+299
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+300
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+301
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+302
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+303
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+304
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+305
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+306
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+307
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+308
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+309
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+310
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+311
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+312
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+313
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+314
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+315
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+316
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+317
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+318
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+319
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+320
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+321
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+322
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+323
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+324
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+325
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+326
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+327
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+328
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+329
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+330
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+331
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+332
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+333
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+334
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+335
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+336
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+337
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+338
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+339
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+340
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+341
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+342
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+343
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+344
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+345
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+346
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+347
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+348
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+349
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+350
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+351
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+352
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+353
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+354
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+355
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+356
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+357
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+358
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+359
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+360
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+361
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+362
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+363
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+364
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+365
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+366
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+367
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+368
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+369
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+370
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+371
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+372
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+373
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+374
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+375
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+376
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+377
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+378
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+379
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+380
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+381
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+382
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+383
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+384
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+385
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+386
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+387
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+388
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+389
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+390
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+391
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+392
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+393
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+394
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+395
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+396
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+397
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+398
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+399
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+400
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+401
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+402
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+403
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+404
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+405
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+406
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+407
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+408
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+409
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+410
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+411
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+412
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+413
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+414
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+415
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+416
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+417
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+418
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+419
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+420
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+421
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+422
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+423
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+424
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+425
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+426
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+427
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+428
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+429
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+430
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+431
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+432
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+433
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+434
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+435
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+436
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+437
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+438
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+439
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+440
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+441
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+442
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+443
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+444
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+445
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+446
    UF_FLAG_PRIVATE,                                        // PLAYER_SKILL_LINEID+447
    UF_FLAG_PRIVATE,                                        // PLAYER_CHARACTER_POINTS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MAX_TALENT_TIERS
    UF_FLAG_PRIVATE,                                        // PLAYER_TRACK_CREATURES
    UF_FLAG_PRIVATE,                                        // PLAYER_TRACK_RESOURCES
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPERTISE
    UF_FLAG_PRIVATE,                                        // PLAYER_OFFHAND_EXPERTISE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RANGED_EXPERTISE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATING_EXPERTISE
    UF_FLAG_PRIVATE,                                        // PLAYER_BLOCK_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_DODGE_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_DODGE_PERCENTAGE_FROM_ATTRIBUTE
    UF_FLAG_PRIVATE,                                        // PLAYER_PARRY_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_PARRY_PERCENTAGE_FROM_ATTRIBUTE
    UF_FLAG_PRIVATE,                                        // PLAYER_CRIT_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_RANGED_CRIT_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_OFFHAND_CRIT_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_SPELL_CRIT_PERCENTAGE1
    UF_FLAG_PRIVATE,                                        // PLAYER_SHIELD_BLOCK
    UF_FLAG_PRIVATE,                                        // PLAYER_SHIELD_BLOCK_CRIT_PERCENTAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_MASTERY
    UF_FLAG_PRIVATE,                                        // PLAYER_SPEED
    UF_FLAG_PRIVATE,                                        // PLAYER_LIFESTEAL
    UF_FLAG_PRIVATE,                                        // PLAYER_AVOIDANCE
    UF_FLAG_PRIVATE,                                        // PLAYER_STURDINESS
    UF_FLAG_PRIVATE,                                        // PLAYER_VERSATILITY
    UF_FLAG_PRIVATE,                                        // PLAYER_VERSATILITY_BONUS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_POWER_DAMAGE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_POWER_HEALING
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+1
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+2
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+3
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+4
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+5
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+6
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+7
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+8
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+9
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+10
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+11
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+12
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+13
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+14
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+15
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+16
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+17
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+18
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+19
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+20
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+21
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+22
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+23
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+24
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+25
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+26
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+27
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+28
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+29
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+30
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+31
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+32
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+33
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+34
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+35
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+36
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+37
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+38
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+39
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+40
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+41
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+42
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+43
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+44
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+45
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+46
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+47
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+48
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+49
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+50
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+51
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+52
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+53
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+54
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+55
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+56
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+57
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+58
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+59
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+60
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+61
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+62
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+63
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+64
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+65
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+66
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+67
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+68
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+69
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+70
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+71
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+72
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+73
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+74
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+75
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+76
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+77
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+78
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+79
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+80
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+81
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+82
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+83
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+84
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+85
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+86
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+87
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+88
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+89
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+90
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+91
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+92
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+93
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+94
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+95
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+96
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+97
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+98
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+99
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+100
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+101
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+102
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+103
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+104
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+105
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+106
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+107
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+108
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+109
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+110
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+111
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+112
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+113
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+114
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+115
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+116
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+117
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+118
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+119
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+120
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+121
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+122
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+123
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+124
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+125
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+126
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+127
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+128
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+129
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+130
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+131
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+132
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+133
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+134
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+135
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+136
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+137
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+138
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+139
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+140
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+141
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+142
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+143
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+144
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+145
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+146
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+147
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+148
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+149
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+150
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+151
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+152
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+153
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+154
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+155
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+156
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+157
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+158
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+159
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+160
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+161
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+162
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+163
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+164
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+165
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+166
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+167
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+168
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+169
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+170
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+171
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+172
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+173
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+174
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+175
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+176
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+177
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+178
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+179
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+180
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+181
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+182
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+183
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+184
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+185
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+186
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+187
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+188
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+189
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+190
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+191
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+192
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+193
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+194
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+195
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+196
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+197
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+198
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+199
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+200
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+201
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+202
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+203
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+204
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+205
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+206
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+207
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+208
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+209
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+210
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+211
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+212
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+213
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+214
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+215
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+216
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+217
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+218
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+219
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+220
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+221
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+222
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+223
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+224
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+225
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+226
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+227
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+228
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+229
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+230
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+231
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+232
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+233
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+234
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+235
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+236
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+237
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+238
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+239
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+240
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+241
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+242
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+243
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+244
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+245
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+246
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+247
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+248
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+249
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+250
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+251
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+252
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+253
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+254
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+255
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+256
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+257
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+258
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+259
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+260
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+261
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+262
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+263
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+264
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+265
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+266
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+267
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+268
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+269
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+270
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+271
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+272
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+273
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+274
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+275
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+276
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+277
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+278
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+279
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+280
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+281
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+282
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+283
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+284
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+285
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+286
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+287
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+288
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+289
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+290
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+291
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+292
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+293
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+294
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+295
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+296
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+297
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+298
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+299
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+300
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+301
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+302
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+303
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+304
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+305
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+306
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+307
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+308
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+309
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+310
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+311
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+312
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+313
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+314
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+315
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+316
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+317
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+318
    UF_FLAG_PRIVATE,                                        // PLAYER_EXPLORED_ZONES_1+319
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_REST_INFO
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_REST_INFO+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_REST_INFO+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_REST_INFO+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_POS+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_NEG+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_DAMAGE_DONE_PERCENT+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_HEALING_DONE_POS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_HEALING_PCT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_HEALING_DONE_PERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_PERIODIC_HEALING_DONE_PERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WEAPON_DMG_MULTIPLIERS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WEAPON_DMG_MULTIPLIERS+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WEAPON_DMG_MULTIPLIERS+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WEAPON_ATK_SPEED_MULTIPLIERS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WEAPON_ATK_SPEED_MULTIPLIERS+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WEAPON_ATK_SPEED_MULTIPLIERS+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_SPELL_POWER_PERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_RESILIENCE_PERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_OVERRIDE_SPELL_POWER_BY_APPERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_OVERRIDE_APBY_SPELL_POWER_PERCENT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_TARGET_RESISTANCE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_TARGET_PHYSICAL_RESISTANCE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_LOCAL_FLAGS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BYTES
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_MEDALS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+9
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+10
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_PRICE+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+9
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+10
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BUYBACK_TIMESTAMP+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_YESTERDAY_HONORABLE_KILLS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_LIFETIME_HONORABLE_KILLS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_WATCHED_FACTION_INDEX
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+9
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+10
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+12
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+13
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+14
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+15
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+16
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+17
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+18
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+19
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+20
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+21
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+22
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+23
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+24
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+25
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+26
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+27
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+28
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+29
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+30
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_COMBAT_RATINGS+31
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+9
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+10
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+12
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+13
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+14
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+15
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+16
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+17
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+18
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+19
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+20
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+21
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+22
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+23
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+24
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+25
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+26
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+27
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+28
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+29
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+30
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+31
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+32
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+33
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+34
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+35
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+36
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+37
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+38
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+39
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+40
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_PVP_INFO+41
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MAX_LEVEL
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_SCALING_PLAYER_LEVEL_DELTA
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MAX_CREATURE_SCALING_LEVEL
    UF_FLAG_PRIVATE,                                        // PLAYER_NO_REAGENT_COST_1
    UF_FLAG_PRIVATE,                                        // PLAYER_NO_REAGENT_COST_1+1
    UF_FLAG_PRIVATE,                                        // PLAYER_NO_REAGENT_COST_1+2
    UF_FLAG_PRIVATE,                                        // PLAYER_NO_REAGENT_COST_1+3
    UF_FLAG_PRIVATE,                                        // PLAYER_PET_SPELL_POWER
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_RESEARCHING+9
    UF_FLAG_PRIVATE,                                        // PLAYER_PROFESSION_SKILL_LINE_1
    UF_FLAG_PRIVATE,                                        // PLAYER_PROFESSION_SKILL_LINE_1+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_UI_HIT_MODIFIER
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_UI_SPELL_HIT_MODIFIER
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_HOME_REALM_TIME_OFFSET
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_MOD_PET_HASTE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BYTES2
    UF_FLAG_PRIVATE | UF_FLAG_URGENT_SELF_ONLY,             // PLAYER_FIELD_BYTES3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_LFG_BONUS_FACTION_ID
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_LOOT_SPEC_ID
    UF_FLAG_PRIVATE | UF_FLAG_URGENT_SELF_ONLY,             // PLAYER_FIELD_OVERRIDE_ZONE_PVP_TYPE
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BAG_SLOT_FLAGS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BAG_SLOT_FLAGS+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BAG_SLOT_FLAGS+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BAG_SLOT_FLAGS+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_BANK_BAG_SLOT_FLAGS+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_INSERT_ITEMS_LEFT_TO_RIGHT
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+2
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+3
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+4
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+5
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+6
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+7
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+8
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+9
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+10
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+11
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+12
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+13
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+14
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+15
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+16
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+17
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+18
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+19
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+20
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+21
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+22
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+23
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+24
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+25
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+26
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+27
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+28
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+29
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+30
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+31
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+32
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+33
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+34
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+35
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+36
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+37
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+38
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+39
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+40
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+41
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+42
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+43
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+44
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+45
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+46
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+47
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+48
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+49
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+50
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+51
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+52
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+53
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+54
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+55
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+56
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+57
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+58
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+59
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+60
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+61
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+62
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+63
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+64
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+65
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+66
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+67
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+68
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+69
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+70
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+71
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+72
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+73
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+74
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+75
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+76
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+77
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+78
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+79
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+80
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+81
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+82
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+83
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+84
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+85
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+86
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+87
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+88
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+89
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+90
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+91
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+92
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+93
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+94
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+95
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+96
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+97
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+98
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+99
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+100
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+101
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+102
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+103
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+104
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+105
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+106
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+107
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+108
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+109
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+110
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+111
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+112
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+113
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+114
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+115
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+116
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+117
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+118
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+119
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+120
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+121
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+122
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+123
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+124
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+125
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+126
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+127
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+128
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+129
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+130
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+131
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+132
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+133
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+134
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+135
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+136
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+137
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+138
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+139
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+140
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+141
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+142
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+143
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+144
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+145
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+146
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+147
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+148
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+149
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+150
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+151
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+152
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+153
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+154
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+155
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+156
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+157
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+158
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+159
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+160
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+161
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+162
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+163
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+164
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+165
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+166
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+167
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+168
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+169
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+170
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+171
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+172
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+173
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+174
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+175
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+176
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+177
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+178
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+179
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+180
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+181
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+182
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+183
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+184
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+185
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+186
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+187
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+188
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+189
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+190
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+191
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+192
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+193
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+194
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+195
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+196
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+197
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+198
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+199
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+200
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+201
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+202
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+203
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+204
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+205
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+206
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+207
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+208
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+209
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+210
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+211
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+212
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+213
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+214
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+215
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+216
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+217
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+218
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+219
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+220
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+221
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+222
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+223
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+224
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+225
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+226
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+227
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+228
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+229
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+230
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+231
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+232
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+233
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+234
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+235
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+236
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+237
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+238
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+239
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+240
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+241
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+242
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+243
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+244
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+245
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+246
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+247
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+248
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+249
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+250
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+251
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+252
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+253
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+254
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+255
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+256
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+257
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+258
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+259
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+260
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+261
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+262
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+263
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+264
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+265
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+266
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+267
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+268
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+269
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+270
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+271
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+272
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+273
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+274
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+275
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+276
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+277
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+278
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+279
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+280
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+281
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+282
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+283
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+284
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+285
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+286
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+287
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+288
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+289
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+290
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+291
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+292
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+293
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+294
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+295
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+296
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+297
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+298
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+299
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+300
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+301
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+302
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+303
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+304
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+305
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+306
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+307
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+308
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+309
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+310
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+311
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+312
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+313
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+314
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+315
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+316
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+317
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+318
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+319
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+320
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+321
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+322
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+323
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+324
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+325
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+326
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+327
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+328
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+329
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+330
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+331
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+332
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+333
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+334
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+335
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+336
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+337
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+338
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+339
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+340
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+341
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+342
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+343
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+344
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+345
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+346
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+347
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+348
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+349
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+350
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+351
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+352
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+353
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+354
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+355
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+356
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+357
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+358
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+359
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+360
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+361
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+362
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+363
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+364
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+365
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+366
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+367
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+368
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+369
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+370
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+371
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+372
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+373
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+374
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+375
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+376
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+377
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+378
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+379
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+380
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+381
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+382
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+383
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+384
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+385
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+386
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+387
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+388
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+389
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+390
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+391
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+392
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+393
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+394
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+395
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+396
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+397
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+398
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+399
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+400
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+401
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+402
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+403
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+404
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+405
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+406
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+407
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+408
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+409
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+410
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+411
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+412
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+413
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+414
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+415
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+416
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+417
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+418
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+419
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+420
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+421
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+422
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+423
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+424
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+425
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+426
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+427
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+428
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+429
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+430
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+431
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+432
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+433
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+434
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+435
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+436
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+437
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+438
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+439
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+440
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+441
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+442
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+443
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+444
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+445
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+446
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+447
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+448
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+449
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+450
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+451
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+452
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+453
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+454
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+455
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+456
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+457
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+458
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+459
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+460
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+461
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+462
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+463
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+464
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+465
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+466
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+467
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+468
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+469
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+470
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+471
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+472
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+473
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+474
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+475
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+476
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+477
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+478
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+479
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+480
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+481
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+482
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+483
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+484
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+485
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+486
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+487
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+488
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+489
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+490
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+491
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+492
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+493
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+494
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+495
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+496
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+497
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+498
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+499
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+500
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+501
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+502
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+503
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+504
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+505
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+506
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+507
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+508
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+509
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+510
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+511
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+512
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+513
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+514
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+515
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+516
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+517
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+518
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+519
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+520
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+521
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+522
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+523
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+524
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+525
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+526
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+527
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+528
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+529
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+530
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+531
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+532
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+533
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+534
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+535
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+536
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+537
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+538
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+539
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+540
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+541
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+542
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+543
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+544
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+545
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+546
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+547
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+548
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+549
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+550
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+551
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+552
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+553
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+554
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+555
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+556
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+557
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+558
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+559
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+560
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+561
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+562
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+563
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+564
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+565
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+566
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+567
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+568
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+569
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+570
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+571
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+572
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+573
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+574
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+575
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+576
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+577
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+578
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+579
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+580
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+581
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+582
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+583
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+584
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+585
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+586
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+587
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+588
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+589
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+590
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+591
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+592
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+593
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+594
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+595
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+596
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+597
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+598
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+599
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+600
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+601
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+602
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+603
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+604
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+605
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+606
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+607
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+608
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+609
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+610
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+611
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+612
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+613
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+614
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+615
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+616
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+617
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+618
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+619
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+620
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+621
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+622
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+623
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+624
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+625
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+626
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+627
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+628
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+629
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+630
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+631
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+632
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+633
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+634
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+635
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+636
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+637
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+638
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+639
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+640
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+641
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+642
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+643
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+644
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+645
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+646
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+647
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+648
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+649
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+650
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+651
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+652
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+653
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+654
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+655
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+656
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+657
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+658
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+659
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+660
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+661
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+662
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+663
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+664
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+665
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+666
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+667
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+668
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+669
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+670
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+671
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+672
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+673
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+674
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+675
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+676
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+677
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+678
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+679
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+680
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+681
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+682
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+683
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+684
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+685
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+686
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+687
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+688
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+689
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+690
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+691
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+692
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+693
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+694
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+695
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+696
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+697
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+698
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+699
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+700
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+701
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+702
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+703
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+704
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+705
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+706
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+707
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+708
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+709
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+710
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+711
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+712
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+713
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+714
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+715
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+716
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+717
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+718
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+719
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+720
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+721
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+722
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+723
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+724
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+725
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+726
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+727
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+728
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+729
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+730
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+731
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+732
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+733
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+734
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+735
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+736
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+737
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+738
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+739
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+740
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+741
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+742
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+743
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+744
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+745
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+746
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+747
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+748
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+749
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+750
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+751
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+752
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+753
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+754
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+755
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+756
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+757
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+758
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+759
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+760
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+761
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+762
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+763
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+764
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+765
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+766
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+767
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+768
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+769
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+770
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+771
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+772
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+773
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+774
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+775
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+776
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+777
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+778
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+779
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+780
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+781
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+782
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+783
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+784
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+785
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+786
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+787
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+788
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+789
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+790
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+791
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+792
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+793
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+794
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+795
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+796
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+797
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+798
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+799
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+800
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+801
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+802
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+803
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+804
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+805
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+806
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+807
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+808
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+809
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+810
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+811
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+812
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+813
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+814
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+815
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+816
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+817
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+818
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+819
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+820
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+821
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+822
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+823
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+824
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+825
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+826
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+827
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+828
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+829
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+830
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+831
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+832
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+833
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+834
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+835
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+836
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+837
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+838
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+839
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+840
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+841
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+842
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+843
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+844
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+845
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+846
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+847
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+848
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+849
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+850
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+851
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+852
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+853
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+854
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+855
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+856
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+857
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+858
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+859
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+860
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+861
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+862
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+863
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+864
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+865
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+866
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+867
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+868
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+869
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+870
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+871
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+872
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+873
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+874
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+875
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+876
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+877
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+878
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+879
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+880
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+881
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+882
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+883
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+884
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+885
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+886
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+887
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+888
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+889
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+890
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+891
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+892
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+893
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+894
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+895
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+896
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+897
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+898
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+899
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+900
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+901
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+902
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+903
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+904
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+905
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+906
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+907
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+908
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+909
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+910
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+911
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+912
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+913
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+914
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+915
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+916
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+917
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+918
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+919
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+920
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+921
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+922
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+923
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+924
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+925
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+926
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+927
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+928
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+929
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+930
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+931
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+932
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+933
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+934
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+935
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+936
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+937
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+938
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+939
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+940
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+941
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+942
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+943
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+944
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+945
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+946
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+947
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+948
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+949
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+950
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+951
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+952
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+953
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+954
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+955
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+956
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+957
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+958
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+959
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+960
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+961
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+962
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+963
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+964
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+965
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+966
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+967
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+968
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+969
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+970
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+971
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+972
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+973
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+974
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+975
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+976
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+977
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+978
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+979
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+980
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+981
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+982
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+983
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+984
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+985
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+986
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+987
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+988
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+989
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+990
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+991
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+992
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+993
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+994
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+995
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+996
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+997
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+998
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+999
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1000
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1001
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1002
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1003
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1004
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1005
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1006
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1007
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1008
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1009
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1010
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1011
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1012
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1013
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1014
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1015
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1016
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1017
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1018
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1019
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1020
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1021
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1022
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1023
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1024
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1025
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1026
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1027
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1028
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1029
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1030
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1031
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1032
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1033
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1034
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1035
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1036
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1037
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1038
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1039
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1040
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1041
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1042
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1043
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1044
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1045
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1046
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1047
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1048
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1049
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1050
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1051
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1052
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1053
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1054
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1055
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1056
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1057
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1058
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1059
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1060
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1061
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1062
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1063
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1064
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1065
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1066
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1067
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1068
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1069
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1070
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1071
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1072
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1073
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1074
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1075
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1076
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1077
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1078
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1079
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1080
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1081
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1082
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1083
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1084
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1085
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1086
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1087
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1088
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1089
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1090
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1091
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1092
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1093
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1094
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1095
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1096
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1097
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1098
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1099
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1100
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1101
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1102
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1103
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1104
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1105
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1106
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1107
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1108
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1109
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1110
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1111
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1112
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1113
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1114
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1115
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1116
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1117
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1118
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1119
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1120
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1121
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1122
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1123
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1124
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1125
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1126
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1127
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1128
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1129
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1130
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1131
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1132
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1133
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1134
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1135
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1136
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1137
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1138
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1139
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1140
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1141
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1142
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1143
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1144
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1145
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1146
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1147
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1148
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1149
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1150
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1151
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1152
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1153
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1154
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1155
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1156
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1157
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1158
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1159
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1160
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1161
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1162
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1163
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1164
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1165
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1166
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1167
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1168
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1169
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1170
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1171
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1172
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1173
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1174
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1175
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1176
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1177
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1178
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1179
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1180
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1181
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1182
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1183
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1184
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1185
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1186
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1187
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1188
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1189
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1190
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1191
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1192
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1193
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1194
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1195
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1196
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1197
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1198
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1199
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1200
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1201
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1202
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1203
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1204
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1205
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1206
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1207
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1208
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1209
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1210
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1211
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1212
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1213
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1214
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1215
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1216
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1217
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1218
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1219
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1220
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1221
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1222
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1223
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1224
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1225
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1226
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1227
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1228
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1229
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1230
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1231
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1232
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1233
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1234
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1235
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1236
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1237
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1238
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1239
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1240
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1241
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1242
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1243
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1244
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1245
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1246
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1247
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1248
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1249
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1250
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1251
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1252
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1253
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1254
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1255
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1256
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1257
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1258
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1259
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1260
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1261
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1262
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1263
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1264
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1265
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1266
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1267
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1268
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1269
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1270
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1271
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1272
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1273
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1274
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1275
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1276
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1277
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1278
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1279
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1280
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1281
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1282
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1283
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1284
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1285
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1286
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1287
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1288
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1289
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1290
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1291
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1292
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1293
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1294
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1295
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1296
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1297
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1298
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1299
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1300
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1301
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1302
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1303
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1304
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1305
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1306
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1307
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1308
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1309
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1310
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1311
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1312
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1313
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1314
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1315
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1316
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1317
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1318
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1319
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1320
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1321
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1322
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1323
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1324
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1325
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1326
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1327
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1328
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1329
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1330
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1331
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1332
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1333
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1334
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1335
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1336
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1337
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1338
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1339
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1340
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1341
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1342
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1343
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1344
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1345
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1346
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1347
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1348
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1349
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1350
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1351
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1352
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1353
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1354
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1355
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1356
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1357
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1358
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1359
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1360
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1361
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1362
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1363
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1364
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1365
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1366
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1367
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1368
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1369
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1370
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1371
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1372
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1373
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1374
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1375
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1376
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1377
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1378
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1379
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1380
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1381
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1382
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1383
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1384
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1385
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1386
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1387
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1388
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1389
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1390
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1391
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1392
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1393
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1394
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1395
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1396
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1397
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1398
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1399
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1400
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1401
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1402
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1403
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1404
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1405
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1406
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1407
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1408
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1409
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1410
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1411
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1412
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1413
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1414
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1415
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1416
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1417
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1418
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1419
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1420
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1421
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1422
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1423
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1424
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1425
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1426
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1427
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1428
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1429
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1430
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1431
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1432
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1433
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1434
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1435
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1436
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1437
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1438
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1439
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1440
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1441
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1442
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1443
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1444
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1445
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1446
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1447
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1448
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1449
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1450
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1451
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1452
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1453
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1454
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1455
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1456
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1457
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1458
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1459
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1460
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1461
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1462
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1463
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1464
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1465
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1466
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1467
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1468
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1469
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1470
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1471
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1472
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1473
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1474
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1475
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1476
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1477
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1478
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1479
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1480
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1481
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1482
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1483
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1484
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1485
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1486
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1487
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1488
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1489
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1490
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1491
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1492
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1493
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1494
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1495
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1496
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1497
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1498
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1499
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1500
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1501
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1502
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1503
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1504
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1505
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1506
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1507
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1508
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1509
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1510
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1511
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1512
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1513
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1514
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1515
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1516
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1517
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1518
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1519
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1520
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1521
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1522
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1523
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1524
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1525
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1526
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1527
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1528
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1529
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1530
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1531
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1532
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1533
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1534
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1535
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1536
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1537
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1538
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1539
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1540
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1541
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1542
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1543
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1544
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1545
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1546
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1547
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1548
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1549
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1550
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1551
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1552
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1553
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1554
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1555
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1556
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1557
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1558
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1559
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1560
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1561
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1562
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1563
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1564
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1565
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1566
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1567
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1568
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1569
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1570
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1571
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1572
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1573
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1574
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1575
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1576
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1577
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1578
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1579
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1580
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1581
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1582
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1583
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1584
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1585
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1586
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1587
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1588
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1589
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1590
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1591
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1592
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1593
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1594
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1595
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1596
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1597
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1598
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1599
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1600
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1601
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1602
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1603
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1604
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1605
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1606
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1607
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1608
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1609
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1610
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1611
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1612
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1613
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1614
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1615
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1616
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1617
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1618
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1619
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1620
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1621
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1622
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1623
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1624
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1625
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1626
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1627
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1628
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1629
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1630
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1631
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1632
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1633
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1634
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1635
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1636
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1637
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1638
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1639
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1640
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1641
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1642
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1643
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1644
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1645
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1646
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1647
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1648
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1649
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1650
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1651
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1652
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1653
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1654
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1655
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1656
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1657
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1658
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1659
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1660
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1661
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1662
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1663
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1664
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1665
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1666
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1667
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1668
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1669
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1670
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1671
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1672
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1673
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1674
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1675
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1676
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1677
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1678
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1679
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1680
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1681
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1682
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1683
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1684
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1685
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1686
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1687
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1688
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1689
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1690
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1691
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1692
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1693
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1694
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1695
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1696
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1697
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1698
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1699
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1700
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1701
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1702
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1703
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1704
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1705
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1706
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1707
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1708
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1709
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1710
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1711
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1712
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1713
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1714
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1715
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1716
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1717
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1718
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1719
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1720
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1721
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1722
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1723
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1724
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1725
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1726
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1727
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1728
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1729
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1730
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1731
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1732
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1733
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1734
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1735
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1736
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1737
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1738
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1739
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1740
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1741
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1742
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1743
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1744
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1745
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1746
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1747
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1748
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_QUEST_COMPLETED+1749
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_HONOR
    UF_FLAG_PRIVATE,                                        // PLAYER_FIELD_HONOR_NEXT_LEVEL
};

uint32 UnitDynamicFieldFlags[PLAYER_DYNAMIC_END] =
{
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_DYNAMIC_FIELD_PASSIVE_SPELLS
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_DYNAMIC_FIELD_WORLD_EFFECTS
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // UNIT_DYNAMIC_FIELD_CHANNEL_OBJECTS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_RESERACH_SITE
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_RESEARCH_SITE_PROGRESS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_DAILY_QUESTS_COMPLETED
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_AVAILABLE_QUEST_LINE_XQUEST_IDS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_HEIRLOOMS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_HEIRLOOM_FLAGS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_TOYS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_TRANSMOG
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_CONDITIONAL_TRANSMOG
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_SELF_RES_SPELLS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_CHARACTER_RESTRICTIONS
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_SPELL_PCT_MOD_BY_LABEL
    UF_FLAG_PRIVATE,                                        // PLAYER_DYNAMIC_FIELD_SPELL_FLAT_MOD_BY_LABEL
    UF_FLAG_PUBLIC,                                         // PLAYER_DYNAMIC_FIELD_ARENA_COOLDOWNS
};

uint32 GameObjectUpdateFieldFlags[GAMEOBJECT_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_FIELD_CREATED_BY
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_FIELD_CREATED_BY+1
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_FIELD_CREATED_BY+2
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_FIELD_CREATED_BY+3
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_DISPLAYID
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // GAMEOBJECT_FLAGS
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_PARENTROTATION
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_PARENTROTATION+1
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_PARENTROTATION+2
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_PARENTROTATION+3
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_FACTION
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_LEVEL
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // GAMEOBJECT_BYTES_1
    UF_FLAG_PUBLIC | UF_FLAG_DYNAMIC | UF_FLAG_URGENT,      // GAMEOBJECT_SPELL_VISUAL_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_SPELL_VISUAL_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_ANIM_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_ANIM_KIT_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_WORLD_EFFECT_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_WORLD_EFFECT_ID+1
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_WORLD_EFFECT_ID+2
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // GAMEOBJECT_STATE_WORLD_EFFECT_ID+3
};

uint32 GameObjectDynamicUpdateFieldFlags[GAMEOBJECT_DYNAMIC_END] =
{
    UF_FLAG_PUBLIC,                                         // GAMEOBJECT_DYNAMIC_ENABLE_DOODAD_SETS
};

uint32 DynamicObjectUpdateFieldFlags[DYNAMIC_OBJECT_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_CASTER
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_CASTER+1
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_CASTER+2
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_CASTER+3
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_TYPE
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_SPELL_X_SPELL_VISUAL_ID
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_SPELLID
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_RADIUS
    UF_FLAG_PUBLIC,                                         // DYNAMICOBJECT_CASTTIME
};

uint32 CorpseUpdateFieldFlags[CORPSE_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_OWNER
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_OWNER+1
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_OWNER+2
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_OWNER+3
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_PARTY
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_PARTY+1
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_PARTY+2
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_PARTY+3
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_DISPLAY_ID
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+1
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+2
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+3
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+4
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+5
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+6
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+7
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+8
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+9
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+10
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+11
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+12
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+13
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+14
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+15
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+16
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+17
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_ITEM+18
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_BYTES_1
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_BYTES_2
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_FLAGS
    UF_FLAG_DYNAMIC,                                        // CORPSE_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_FACTIONTEMPLATE
    UF_FLAG_PUBLIC,                                         // CORPSE_FIELD_CUSTOM_DISPLAY_OPTION
};

uint32 AreaTriggerUpdateFieldFlags[AREA_TRIGGER_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE+1
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE+2
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE+3
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE+4
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE+5
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_OVERRIDE_SCALE_CURVE+6
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE+1
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE+2
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE+3
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE+4
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE+5
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_EXTRA_SCALE_CURVE+6
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CASTER
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CASTER+1
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CASTER+2
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CASTER+3
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_DURATION
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_TIME_TO_TARGET
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_TIME_TO_TARGET_SCALE
    UF_FLAG_PUBLIC | UF_FLAG_URGENT,                        // AREATRIGGER_TIME_TO_TARGET_EXTRA_SCALE
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_SPELLID
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_SPELL_FOR_VISUALS
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_SPELL_X_SPELL_VISUAL_ID
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // AREATRIGGER_BOUNDS_RADIUS_2D
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_DECAL_PROPERTIES_ID
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CREATING_EFFECT_GUID
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CREATING_EFFECT_GUID+1
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CREATING_EFFECT_GUID+2
    UF_FLAG_PUBLIC,                                         // AREATRIGGER_CREATING_EFFECT_GUID+3
};

uint32 SceneObjectUpdateFieldFlags[SCENEOBJECT_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_SCRIPT_PACKAGE_ID
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_RND_SEED_VAL
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_CREATEDBY
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_CREATEDBY+1
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_CREATEDBY+2
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_CREATEDBY+3
    UF_FLAG_PUBLIC,                                         // SCENEOBJECT_FIELD_SCENE_TYPE
};

uint32 ConversationUpdateFieldFlags[CONVERSATION_END] =
{
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_GUID+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+1
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+2
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_DATA+3
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_TYPE
    UF_FLAG_DYNAMIC,                                        // OBJECT_FIELD_ENTRY
    UF_FLAG_DYNAMIC | UF_FLAG_URGENT,                       // OBJECT_FIELD_DYNAMIC_FLAGS
    UF_FLAG_PUBLIC,                                         // OBJECT_FIELD_SCALE
    UF_FLAG_DYNAMIC,                                        // CONVERSATION_LAST_LINE_END_TIME
};

uint32 ConversationDynamicFieldFlags[CONVERSATION_DYNAMIC_END] =
{
    UF_FLAG_PUBLIC,                                         // CONVERSATION_DYNAMIC_FIELD_ACTORS
    UF_FLAG_UNK0X100,                                       // CONVERSATION_DYNAMIC_FIELD_LINES
};
